//sidebar specific
function refreshNews() {
	news = document.getElementById('devboiNews');
	updateTree(news);
	setTimeout('refreshNews();', 60*60*1000);
}

function initializeDevBoiTrees() {
	var trees = document.getElementsByTagName('tree');
	for(var i = 0; i<trees.length; i++) {
		evt.add(trees[i], 'keypress', processKey);
		evt.add(trees[i], 'dblclick', processDblClick);
		evt.add(trees[i], 'mousedown', processMiddleClick);
		cols = trees[i].getElementsByTagName('treecol');
		for(var j = cols.length-1; j>=0; j--) {
			if(cls.has(trees[i], 'copyPaste') && cls.has(cols[j], 'copyPaste')) {
				trees[i].copyPasteElm = cols[j].getAttribute('id');
			} else {
				if(cls.has(cols[j], 'link')) {
					trees[i].linkElm = cols[j].getAttribute('id');
				}
			}
		}
	}
}

function initializeDevBoiTabs() {
	//initialize dropdown controls
	var menus = document.getElementsByTagName('menulist');
	var classes = '';
	var controls = '';
	for(var i = 0; i<menus.length; i++) {
		classes = menus[i].getAttribute('class').split(' ');
		for(var j = 0; j<classes.length; j++) {
			if(classes[j].indexOf('controls_') == 0) {
				controls = classes[j].split('_')[1];
				menus[i].linkedTab = document.getElementById(controls).getElementsByTagName('tabpanels')[0];
				if(menus[i].linkedTab.childNodes.length > 0) {
					var si = menus[i].linkedTab.selectedIndex >= 0 ? menus[i].linkedTab.selectedIndex : 0;
					if(si<menus[i].childNodes.length) {
						item = document.getElementById('item_' + menus[i].linkedTab.childNodes[si].getAttribute('id'));
						menus[i].selectedItem = item;
					}
					evt.add(menus[i], 'command', onSelectCommand);
				}
			}
		}
	}

	var tabs = document.getElementsByTagName('tabpanels');
	for(var i = 0; i<tabs.length; i++) {
	}
}

function devboiLog(message) {
	document.getElementById('devboi_log').value = message;
}

function onSelectCommand(e) {
	var target = e.target;
	while(target.tagName != 'menulist') { target = target.parentNode; }
	target.linkedTab.selectedPanel = document.getElementById(e.target.id.substr(5));
}

function InitializeDevBoi() {
	initializeDevBoiTrees();
	initializeDevBoiTabs();
	refreshNews();
	
	var menu = document.getElementById('devboi_menu');
	if((!menu.lastChild) || ((menu.lastChild) && (menu.lastChild.tagName != 'menuseparator'))) {
		var separator = document.createElement('menuseparator');
		menu.appendChild(separator);
	}
	var add_button = document.createElement('menuitem');
	add_button.setAttribute('label', 'Add more packages,...');
	// add_button.setAttribute('image', 'images/button-add-package.png');
	add_button.setAttribute('style', 'background-image: url(images/button-add-package.png); background-repeat: no-repeat; background-position: 3px center; padding-left: 20px;');
	add_button.setAttribute('oncommand', 'devboi_addPackages()');
	menu.appendChild(add_button);
	
}


function processDefault(target, newTab) {
	if(target.linkElm) {
		gotoLink(target, target.linkElm, newTab);
	} else if(target.copyPasteElm) {
		putValToClipboard(target, target.copyPasteElm)
	}
}
function processKey(e) {
	if(e.keyCode == 13) {
		var t = e.target;
		while(t.tagName != 'tree') t = t.parentNode;
		processDefault(t, e.ctrlKey);
	}
	return true;
}

function processDblClick(e) {
	var t = e.target;
	while(t.tagName != 'tree') t = t.parentNode;
	processDefault(t);
}

function processMiddleClick(e) {
	if((e.which == 2) || (e.ctrlKey)) {
		var t = e.target;
		while(t.tagName != 'tree') t = t.parentNode;
		processDefault(t, true);
	}
	return false;
}

function processTabSelect(e) {
	alert('processTabSelect ' + e.selectedIndex);
}

function devboi_addPackages() {
	showInMainframe('http://www.martincohen.info/products/devboi/packages/', true);
}
/*
function QI(aObj, aIID) {
	return aObj.QueryInterface(Components.interfaces[aIID]);
}

function getService(aCID, aIID) {
	return Components.classes["@mozilla.org/"+aCID]
		.getService(Components.interfaces[aIID]);
}

var emAttributes = {name: "", version: "", disabled: "", internalName: "",
			 homepageURL: "", description: "", creator: ""};
			 
function getAddonsList() {
    function getValue(aArcName) {
      var target = extensionDS.GetTarget(element, emArcs[aArcName], true);
      if(target) return QI(target, "nsIRDFLiteral").Value;
      return "";
    }
	
	var aTarget = 'extension';
	
    const XMLNS_EM = "http://www.mozilla.org/2004/em-rdf#";
    var rdfService = getService("rdf/rdf-service;1", "nsIRDFService");
    var container = getService("rdf/container;1", "nsIRDFContainer");
    var extensionDS = getService("extensions/manager;1",
      "nsIExtensionManager").datasource;
      
    // get the enumerator of all addons of type aTarget --> |elements|
    var root = rdfService.GetResource("urn:mozilla:" + aTarget + ":root");
    container.Init(extensionDS, root);
    var elements = container.GetElements();

    // RDF arcs available for each addon
    var attr, emArcs = [];
    for(attr in this.emAttributes)
		emArcs[attr] = rdfService.GetResource(XMLNS_EM + attr);
		
	while(elements.hasMoreElements())
	{
		var element = elements.getNext();
		try {
			QI(element, "nsIRDFResource");
			if(element.Value.indexOf("http://") == 0)
				continue;
			
			for (attr in this.emAttributes) {
				var val = getValue(attr);
				if(val != "") // "name" is handled above
					alert(attr + ' = ' + val)
			}
		} catch(e) {
			window.alert(e);
		}
	}
}
*/

/*
function outputAddonsList(aTarget)
{
 var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
              .getService(Components.interfaces.nsIRDFService);
 var Container = Components.classes["@mozilla.org/rdf/container;1"]
              .getService(Components.interfaces.nsIRDFContainer);
 var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
              .createInstance(Components.interfaces.nsIFileOutputStream);
 var fp = Components.classes["@mozilla.org/filepicker;1"]
              .createInstance(Components.interfaces.nsIFilePicker);

 fp.init(window, aTarget+'s List', fp.modeSave);
 fp.defaultString=aTarget+"sList.txt";
 fp.appendFilters(fp.filterText);
 fp.appendFilters(fp.filterAll);
 if (fp.show() == fp.returnCancel)
   return;

 var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
   .getService(Components.interfaces.nsIExtensionManager).datasource;
 var root = RDFService
                .GetResource("urn:mozilla:"+aTarget.toLowerCase()+":root");
 var nameArc = RDFService
                .GetResource("http://www.mozilla.org/2004/em-rdf#name");
 var aboutArc = RDFService
                .GetResource("http://www.w3.org/1999/02/22-rdf-syntax-ns#about");
 var versionArc = RDFService
                .GetResource("http://www.mozilla.org/2004/em-rdf#version");
 var disabledArc = RDFService
                .GetResource("http://www.mozilla.org/2004/em-rdf#disabled");

 var list="";
 var disabledlist="";

 Container.Init(extensionDS,root);
 var elements=Container.GetElements();

 while(elements.hasMoreElements())
 {
   var element=elements.getNext();
   var name="";
   var version="";
   var disabled="";
   var about="";
   element.QueryInterface(Components.interfaces.nsIRDFResource);
   alert(element);
   var target=extensionDS.GetTarget(element, aboutArc ,true);
   if(target)
     about=target
       .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
   var target=extensionDS.GetTarget(element, nameArc ,true);
   if(target)
     name=target
       .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
   target=extensionDS.GetTarget(element, versionArc ,true);
   if(target)
     version=target
       .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
   target=extensionDS.GetTarget(element, disabledArc ,true);
   if(target)
     disabled=target
       .QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
   if( disabled && disabled=="true")
     disabledlist += name + " " + version +"\n";
   else if(name)
     list += about + " " + name + " " + version +"\n"
 }

 if(disabledlist)
   list += "\n#Disabled Extensions\n" + disabledlist;

 stream.init(fp.file, 0x20|0x02|0x08, 0666, 0);
 stream.write(list, list.length);
 stream.close();
}

try{
 outputAddonsList("Extension");
 outputAddonsList("Theme");
}catch(e){ window.alert(e); }
*/

