/* settings.js: version 2.1 - 3/13/2006 2:51PM */

var li_PrefBranchPrefix = "local_install."
var addonsEnabled = nsPreferences.getBoolPref("local_install.addonsEnabled");

var mySettings = {

  gBaseExtensionDir: null,
  gBaseThemeDir: null,

  gArchiveExtensionDir: null,
  gArchiveThemeDir: null,

  gDefaultCSSEditor: null,
  gDefaultJSEditor: null,

  init: function() {
    local_common.init();

    /* Fix for display issue with mini-themes had to change init and sizeToContent(); order in onload too */
    var selectedTheme = nsPreferences.copyUnicharPref("general.skins.selectedSkin");
    switch (selectedTheme) {
      case "miniFox":
      case "miniFoxFlat":
      case "minibird":
        document.getElementById("miniThemeFix").hidden = false;
        break;
    }

    try {
      document.getElementById("myExtra1").setAttribute("disabled", "true");
    } catch(ex) {
    }

    var i;
    var thisTagList = "";
    var objectEnableApply = ['checkbox', 'menupopup', 'textbox']; //'button'

    for(var o in objectEnableApply) {
      thisTagList = document.getElementsByTagName(objectEnableApply[o]);
      for (i = 0; i < thisTagList.length; i++) {
        thisTagList[i].addEventListener("click", mySettings.enableApply, true);
      }
    }

    nsPreferences.setBoolPref(li_PrefBranchPrefix + "extensions.checkCompatibility", nsPreferences.getBoolPref("extensions.checkCompatibility"), true);

    nsPreferences.setBoolPref(li_PrefBranchPrefix + "extensions.hideInstallButton", nsPreferences.getBoolPref("extensions.hideInstallButton"), false);

    this.getSettings();

    return true;
  },

  getSettings: function() {

    var prefs = nsPreferences.mPrefService;

    try {
      this.gBaseExtensionDir = prefs.getComplexValue(li_PrefBranchPrefix + "base_extension_dir_local", local_common.myLocalFile)
    } catch (ex) {
      this.gBaseExtensionDir = null;
    }

    try {
      this.gBaseThemeDir = prefs.getComplexValue(li_PrefBranchPrefix + "base_theme_dir_local", local_common.myLocalFile)
    } catch (ex) {
      this.gBaseThemeDir = null;
    }

    try {
      this.gArchiveExtensionDir = prefs.getComplexValue(li_PrefBranchPrefix + "base_extension_dir", local_common.myLocalFile)
    } catch (ex) {
      this.gArchiveExtensionDir = null;
    }

    try {
      this.gArchiveThemeDir = prefs.getComplexValue(li_PrefBranchPrefix + "base_theme_dir", local_common.myLocalFile)
    } catch (ex) {
      this.gArchiveThemeDir = null;
    }

    this.gDefaultCSSEditor = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "default_CSS_editor");
    this.gDefaultJSEditor = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "default_JS_editor");

    /* 3-1-06: Set all Checkbox values with matching pref */
    var thisTagList = document.getElementsByTagName('checkbox');
    for (var i = 0; i < thisTagList.length; i++) {
        thisTagList[i].checked = nsPreferences.getBoolPref(li_PrefBranchPrefix + thisTagList[i].id);
    }

    document.getElementById("SettingsTabs").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_tab");

    document.getElementById("SettingsSubTab1").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab1");

    document.getElementById("SettingsSubTab2").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab2");

    document.getElementById("SettingsSubTab3").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab3");

    document.getElementById("SettingsSubTab4").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab4");

    document.getElementById("SettingsSubTab5").selectedIndex = 
      nsPreferences.getIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab5");

    document.getElementById("throbberURL").value = local_common.getThrobberURL();

    try {
      document.getElementById("txtUserExtensionPath").value = this.gBaseExtensionDir.path;
    } catch (ex) {
      document.getElementById("txtUserExtensionPath").value = "";
    }

    try {
      document.getElementById("txtUserThemePath").value = this.gBaseThemeDir.path;
    } catch (ex) {
      document.getElementById("txtUserThemePath").value = "";
    }

    try {
      document.getElementById("txtUserExtensionArchivePath").value = this.gArchiveExtensionDir.path;
    } catch (ex) {
      document.getElementById("txtUserExtensionArchivePath").value = "";
    }

    try {
      document.getElementById("txtUserThemeArchivePath").value = this.gArchiveThemeDir.path;
    } catch (ex) {
      document.getElementById("txtUserThemeArchivePath").value = "";
    }

    document.getElementById("txtUserCSSPath").value = this.gDefaultCSSEditor;
    document.getElementById("txtUserJSPath").value = this.gDefaultJSEditor;

    var element = document.getElementById("aboutWindowTarget");
    var prefstring = element.getAttribute("prefstring");
    element.selectedItem = element.getElementsByAttribute("value", nsPreferences.getIntPref(prefstring))[0];
    
    element = document.getElementById("WindowTargetMyConfig");
    prefstring = element.getAttribute("prefstring");
    element.selectedItem = element.getElementsByAttribute("value", nsPreferences.getIntPref(prefstring))[0];

    element = document.getElementById("WindowTargetChromeEditor");
    prefstring = element.getAttribute("prefstring");
    element.selectedItem = element.getElementsByAttribute("value", nsPreferences.getIntPref(prefstring))[0];

/*    if (addonsEnabled) {
      var addonsItems = document.getElementsByAttribute("addons", "false");

      for (i in addonsItems) {
        addonsItems[i].disabled = true;
      }
    } else {
      var addonsItems = document.getElementsByAttribute("addons", "true");

      for (i in addonsItems) {
        addonsItems[i].disabled = false;
      }
    }
*/
    if (myBrandShortName == "Mozilla") {
      var items = document.getElementsByAttribute("ffoxonly", "true");

      for (i in items) {
        items[i].disabled = true;
        items[i].checked = false;
      }

      var mozDelayCheck = nsPreferences.getIntPref("security.dialog_enable_delay")

      if (mozDelayCheck != 2000) {
        setCheckedElementById("disableInstallDelay",  true);
      } else {
        setCheckedElementById("disableInstallDelay",  false);
      }
    } else {
      setCheckedElementById("disableInstallDelay", nsPreferences.getBoolPref(li_PrefBranchPrefix + "disableInstallDelay"));
    }

    var titleTemplate = document.getElementById("customTitle");
  	titleTemplate.value = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "titleTemplate");
    
    setCheckedElementById("enableInstall", nsPreferences.getBoolPref("xpinstall.enabled"));

    element = document.getElementById("WindowTarget");
    var element2 = document.getElementById("WindowTargetMyConfig");
    var element3 = document.getElementById("WindowTargetChromeEditor");

    /* Very specific order for disabling and cascading through switch */
    switch (myBrandShortName) {
      case "Thunderbird":
        disableCheckbox("ToolsThemes")
        
        document.getElementById("showAttachmentBox").disabled = false;

        disableCheckbox("enableSessionManagerResume")
      
      case "Sunbird":
      case "Nvu":
        element.disabled = true;
        element2.disabled = true;
        element3.disabled = true;
        element3 = document.getElementById("settings.chromeEditor.label");
        element3.disabled = true;
        
  //      document.getElementById("WindowTargetLabel").disabled = true;
        document.getElementById("aboutWindowTargetLabel").disabled = true;
        document.getElementById("aboutWindowTarget").disabled = true;
        document.getElementById("showSoftwareUpdate").disabled = true;
        document.getElementById("enableInstallButton").disabled = true;

        disableCheckbox("hideArchiveXPI");
        disableCheckbox("hideArchiveJAR");
        disableCheckbox("hidePasteBuildID");
  
        if (myBrandShortName == "Nvu") {
          document.getElementById("hideHelpGetExtensions").disabled = true;
          document.getElementById("hideHelpGetThemes").disabled = true;
        }

        if (myBrandShortName == "Nvu" || myBrandShortName == "Thunderbird") {
          document.getElementById("hideHelpAbout").disabled = true;
        }

        if (myBrandShortName == "Nvu" || myBrandShortName == "Sunbird") {
          disableCheckbox("showBuildinWindowTitle");
          document.getElementById("customTitle").disabled = true;
          document.getElementById("varList").disabled = true;
        }

        break;

      default:
        prefstring = element.getAttribute("prefstring");
        element.selectedItem = element.getElementsByAttribute("value", nsPreferences.getIntPref(prefstring))[0];
    }

    if (!local_common.IsOldBrowser()) {
      document.getElementById("showSoftwareUpdate").disabled = true;
    } else {
      document.getElementById("hideFileRestart").disabled = true;

      disableCheckbox("promptToRestart");
      disableCheckbox("hideRepairExtensions");
      disableCheckbox("promptOnThemeChange");
      disableCheckbox("enableSessionManagerResume");
      disableCheckbox("showRestartMenuButton");
      disableCheckbox("rightAlignAddonVersion");
    }

    var myStyle = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "myConfig.Style");
    
    if (myStyle == "") {
      myStyle = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "myConfig.Style.Default");
    }

    document.getElementById("myConfig.Style").value = myStyle;

    if (addonsEnabled) {
      disableCheckbox("showEMMenuButton");
      disableCheckbox("showTMMenuButton");
      disableCheckbox("extensionSortList");
      disableCheckbox("themeSortList");
    } else {
      disableCheckbox("showAddonsMyConfigImage");
      disableCheckbox("extensions.checkCompatibility");
      disableCheckbox("hideAddonsbarLabels");
    }

    return true;
  },

  acceptChanges: function() {

    try {
      document.getElementById("myExtra1").setAttribute("disabled", "true");
    } catch(ex) {
    }

    this.setLastTab();

    var currentLocation = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile)

    /* 3-1-06: Set all Checkbox values with matching pref */
    var thisTagList = document.getElementsByTagName('checkbox');
    for (var i = 0; i < thisTagList.length; i++) {
      nsPreferences.setBoolPref(li_PrefBranchPrefix + thisTagList[i].id, thisTagList[i].checked);
    }

    //var prefs = nsPreferences.mPrefService;

    try {
      currentLocation.initWithPath(document.getElementById("txtUserExtensionPath").value);
      this.gBaseExtensionDir = currentLocation;
      //nsPreferences.setUnicharPref("local_install.base_extension_dir", this.gBaseExtensionDir);
      local_common.setComplexPref(li_PrefBranchPrefix + "base_extension_dir_local", local_common.myLocalFile, this.gBaseExtensionDir);
    } catch (ex) {
      nsPreferences.setUnicharPref("local_install.base_extension_dir_local", "");
    }

    try {
      currentLocation.initWithPath(document.getElementById("txtUserThemePath").value);
      this.gBaseThemeDir = currentLocation;
      //nsPreferences.setUnicharPref("local_install.base_theme_dir", this.gBaseThemeDir);
      local_common.setComplexPref(li_PrefBranchPrefix + "base_theme_dir_local", local_common.myLocalFile, this.gBaseThemeDir);
    } catch (ex) {
      nsPreferences.setUnicharPref("local_install.base_theme_dir_local", "");
    }

    try {
      currentLocation.initWithPath(document.getElementById("txtUserExtensionArchivePath").value);
      local_common.setComplexPref(li_PrefBranchPrefix + "base_extension_dir", local_common.myLocalFile, currentLocation);
    } catch (ex) {
      nsPreferences.setUnicharPref("local_install.base_extension_dir", "");
    }

    try {
      currentLocation.initWithPath(document.getElementById("txtUserThemeArchivePath").value);
      local_common.setComplexPref(li_PrefBranchPrefix + "base_theme_dir", local_common.myLocalFile, currentLocation);
    } catch (ex) {
      nsPreferences.setUnicharPref("local_install.base_theme_dir", "");
    }

    var myThrobberPref = null;
    
    switch (myBrandShortName) {
      case "Thunderbird":
        myThrobberPref = "messenger.throbber.url"
        break;
      case "Nvu":
        myThrobberPref = "editor.throbber.url"
        break;
      default:
        myThrobberPref = "browser.throbber.url"
    }

    nsPreferences.setUnicharPref(myThrobberPref, document.getElementById("throbberURL").value);

    this.gDefaultCSSEditor = document.getElementById("txtUserCSSPath").value;
    nsPreferences.setUnicharPref(li_PrefBranchPrefix + "default_CSS_editor", this.gDefaultCSSEditor);

    this.gDefaultJSEditor = document.getElementById("txtUserJSPath").value;
    nsPreferences.setUnicharPref(li_PrefBranchPrefix + "default_JS_editor", this.gDefaultJSEditor);


    // integrate with actual built-in preference
    setPrefsElementById("extensions.checkCompatibility", "extensions.checkCompatibility");
    setPrefsElementById("extensions.hideInstallButton", "extensions.hideInstallButton");


    /* about: window Target */
    var windowTargetValue = 0;
    var element = document.getElementById("aboutWindowTarget");
    if (element) {
      windowTargetValue = element.selectedItem.value;
    }
    nsPreferences.setIntPref(element.getAttribute("prefstring"), windowTargetValue);
    
    /* My Config windowTarget */
    windowTargetValue = 2;
    element = document.getElementById("WindowTargetMyConfig");
    if (element) {
      windowTargetValue = element.selectedItem.value;
    }
    nsPreferences.setIntPref(element.getAttribute("prefstring"), windowTargetValue);

    /* Chrome Editor window Target */
    windowTargetValue = 2;
    element = document.getElementById("WindowTargetChromeEditor");
    if (element) {
      windowTargetValue = element.selectedItem.value;
    }
    nsPreferences.setIntPref(element.getAttribute("prefstring"), windowTargetValue);

    var titleTemplate = document.getElementById("customTitle");
    nsPreferences.setUnicharPref(li_PrefBranchPrefix + "titleTemplate", titleTemplate.value);

    setPrefsElementById("enableInstall", "xpinstall.enabled");

    if (myBrandShortName == "Mozilla") {
      if (document.getElementById("disableInstallDelay").checked) {
        nsPreferences.setIntPref("security.dialog_enable_delay", 0);
      } else {
        nsPreferences.setIntPref("security.dialog_enable_delay", 2000);
      }
    } else {
      setPrefsElementById("disableInstallDelay", li_PrefBranchPrefix + "disableInstallDelay");
    }

    windowTargetValue = 0;
    element = document.getElementById("WindowTarget");
    if (element) {
      windowTargetValue = element.selectedItem.value;
    }

    nsPreferences.setIntPref(element.getAttribute("prefstring"), windowTargetValue);

    var defaultStyle = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "myConfig.Style.Default");
    
    if (defaultStyle == document.getElementById("myConfig.Style").value) {
      nsPreferences.setUnicharPref(li_PrefBranchPrefix + "myConfig.Style", "");
    } else {
      nsPreferences.setUnicharPref(li_PrefBranchPrefix + "myConfig.Style", document.getElementById("myConfig.Style").value);
    }

    return true;
  },

  browse: function(aElementId) {
    var mDirPicker = Components.classes['@mozilla.org/filepicker;1'].createInstance(local_common.myFilePicker)

    var mStrings = document.getElementById("InstallButtonStrings");
    mDirPicker.init(window, mStrings.getString("PickDirectory"), mDirPicker.modeGetFolder);
  
    var mlocationField = document.getElementById(aElementId)

    try {
      var mLocation = mlocationField.value;

      if (mLocation) {
        var currentLocation = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile)
        currentLocation.initWithPath(mLocation);
        mDirPicker.displayDirectory = currentLocation;
      }

      mLocation = null;
    } catch (e) {
      local_common.debug(e);
    }
    
    var retVal = mDirPicker.show();

    if(retVal == mDirPicker.returnOK) {
      if (mlocationField.value != mDirPicker.file.path) {
        this.enableApply();
      }
      mlocationField.value = mDirPicker.file.path;
    }

  },

  browseEditor: function(aElementId) {
    var mDirPicker = Components.classes['@mozilla.org/filepicker;1'].createInstance(local_common.myFilePicker)

    mDirPicker.init(window, "", mDirPicker.modeOpen);
  
    var mlocationField = document.getElementById(aElementId)

    try {
      var mLocation = mlocationField.value;

      if (mLocation) {
        var currentLocation = Components.classes['@mozilla.org/file/local;1'].createInstance(Components.interfaces.nsILocalFile)
        currentLocation.initWithPath(mLocation);
        mDirPicker.displayDirectory = currentLocation;
      }

      mLocation = null;
    } catch (e) {
      local_common.debug(e);
    }
    
    mDirPicker.appendFilters(local_common.myFilePicker.filterApps);
    var retVal = mDirPicker.show();

    if(retVal == mDirPicker.returnOK) {
      if (mlocationField.value != mDirPicker.file.persistentDescriptor) {
        this.enableApply();
      }
      mlocationField.value = mDirPicker.file.persistentDescriptor;
    }

  },

  setLastTab: function() {
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_tab", document.getElementById("SettingsTabs").selectedIndex);
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab1", document.getElementById("SettingsSubTab1").selectedIndex);
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab2", document.getElementById("SettingsSubTab2").selectedIndex);
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab3", document.getElementById("SettingsSubTab3").selectedIndex);
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab4", document.getElementById("SettingsSubTab4").selectedIndex);
    nsPreferences.setIntPref(li_PrefBranchPrefix + "selected_settings_sub_tab5", document.getElementById("SettingsSubTab5").selectedIndex);
  },
  
  enableApply: function() {
    document.getElementById("myExtra1").setAttribute("disabled", "false");
  },
  
  resetStyle: function() {
    nsPreferences.setUnicharPref(li_PrefBranchPrefix + "myConfig.Style", "");

    document.getElementById("myConfig.Style").value = nsPreferences.copyUnicharPref(li_PrefBranchPrefix + "myConfig.Style.Default");
  },

  openMyAllowedSites: function(myEvent) {

    if (local_common.IsOldBrowser()) {
      var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
        getService(Components.interfaces.mozIJSSubScriptLoader);
      loader.loadSubScript("chrome://browser/content/pref/pref-features.js");
      showExceptions(myEvent);

    } else {
      var bundlePreferences = document.getElementById("bundlePreferences");

      var params = { blockVisible: false, sessionVisible: false, allowVisible: true, prefilledHost: "", permissionType: "install" };

      params.windowTitle = bundlePreferences.getString("installpermissionstitle");
      params.introText = bundlePreferences.getString("installpermissionstext");

      var features = "resizable,dialog=no,centerscreen";

      window.openDialog("chrome://browser/content/preferences/permissions.xul", "_blank", features, params);
    }
  },
  
  exportData: function() {

    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(li_PrefBranchPrefix);
    var prefCount = {value:0}; 
    var prefArray = nsIPrefBranchObj.getChildList("" , prefCount); 

    //local_common.debug(prefCount.value);

    var stream = Components.classes['@mozilla.org/network/file-output-stream;1']
                 .createInstance(Components.interfaces.nsIFileOutputStream);
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(local_common.myFilePicker)

    fp.init(window, "", fp.modeSave);
    fp.defaultExtension = "txt";
    fp.defaultString = myBrandShortName.toLowerCase() + "_li_prefs.txt";
    fp.appendFilters(fp.filterText);
    fp.appendFilters(fp.filterAll);

    if (fp.show() == fp.returnCancel)
      return;

    var str = ""

    prefArray.sort();

    for (var i = 0; i < prefArray.length; ++i) {

      switch (nsIPrefBranchObj.getPrefType(prefArray[i])) {
        case nsIPrefBranchObj.PREF_STRING:  // Text = 32
          str += "nsPreferences.setUnicharPref('" + li_PrefBranchPrefix + prefArray[i] + "', '";
          str += nsPreferences.copyUnicharPref(li_PrefBranchPrefix + prefArray[i]).replace(/\\/g, '\\\\'); 
          str += "')";
          break;
        case nsIPrefBranchObj.PREF_INT:  // Integer = 64
          str += "nsPreferences.setIntPref('" + li_PrefBranchPrefix + prefArray[i] + "', ";
          str += nsPreferences.getIntPref(li_PrefBranchPrefix + prefArray[i]);
          str += ")";
          break;
        case nsIPrefBranchObj.PREF_BOOL:  // Boolean =128
          str += "nsPreferences.setBoolPref('" + li_PrefBranchPrefix + prefArray[i] + "', "; 
          str += nsPreferences.getBoolPref(li_PrefBranchPrefix + prefArray[i]);
          str += ")";
          break;
      }

      str += "\r\n"
    }
    
    str += "nsPreferences.setIntPref('security.dialog_enable_delay', ";
    str += nsPreferences.getIntPref("security.dialog_enable_delay") + ")\r\n";

    str += "nsPreferences.setIntPref('about_about.aboutWindowTarget', ";
    str += nsPreferences.getIntPref("about_about.aboutWindowTarget") + ")\r\n";


    var exportTheseToo = ['xpinstall.enabled', 'nightly.idtitle', 'nightly.showExtensionConfirm', 'nightly.showEnableAll',
    'extensions.checkCompatibility', 'extensions.hideInstallButton'];
    
    for (i = 0; i < exportTheseToo.length; ++i) {
      str += "nsPreferences.setBoolPref('" + exportTheseToo[i] + "', ";
      str += nsPreferences.getBoolPref("'" + exportTheseToo[i] + "'") + ")\r\n";
    } 

    stream.init(fp.file, 0x20|0x02|0x08, 0666, 0);
    stream.write(str, str.length);
    stream.close();
  },
  
  importData: function(bReset) {
    var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(local_common.myFilePicker)

    fp.init(window, "", local_common.myFilePicker.modeOpen);
    fp.defaultString = myBrandShortName.toLowerCase() + "_li_prefs.txt";
    fp.defaultExtension = "txt";
    fp.appendFilters(fp.filterText);
    fp.appendFilters(fp.filterAll);

    var retVal = fp.show()

    if (retVal == local_common.myFilePicker.returnOK) {
      var mIOService = Components.classes["@mozilla.org/network/io-service;1"]
                         .getService(Components.interfaces.nsIIOService)
      var mFileProtocolHandler = mIOService.getProtocolHandler("file")
                                   .QueryInterface(Components.interfaces.nsIFileProtocolHandler)
      var mURL = mFileProtocolHandler.newFileURI(fp.file)
                   .QueryInterface(Components.interfaces.nsIURL);

      var loader = Components.classes["@mozilla.org/moz/jssubscript-loader;1"].
        getService(Components.interfaces.mozIJSSubScriptLoader);
      loader.loadSubScript(mURL.spec);
  
      mySettings.getSettings();
    }

  },
  
  resetToDefault: function() {
    var prefService = Components.classes["@mozilla.org/preferences-service;1"].
      getService(Components.interfaces.nsIPrefService);

    var nsIPrefBranchObj = prefService.getBranch(li_PrefBranchPrefix);
    var prefCount = {value:0}; 
    var prefArray = nsIPrefBranchObj.getChildList("" , prefCount); 

    var branchService = Components.classes["@mozilla.org/preferences-service;1"]
                                   .getService(Components.interfaces.nsIPrefBranch);

    for (var i = 0; i < prefArray.length; ++i) {
//      local_common.debug(li_PrefBranchPrefix + prefArray[i]);
      if (branchService.prefHasUserValue(li_PrefBranchPrefix + prefArray[i])) {
         branchService.clearUserPref(li_PrefBranchPrefix + prefArray[i]);
      }
    } 

    var resetTheseToo = ['security.dialog_enable_delay', 'about_about.aboutWindowTarget', 
    'xpinstall.enabled', 'nightly.idtitle', 'nightly.showExtensionConfirm', 'nightly.showEnableAll',
    'extensions.checkCompatibility', 'extensions.hideInstallButton'];

    for (i = 0; i < resetTheseToo.length; ++i) {
      if (branchService.prefHasUserValue(resetTheseToo[i])) {
         branchService.clearUserPref(resetTheseToo[i]);
      }
    } 

    mySettings.getSettings();
  }
  
};

function disableCheckbox(elementID, isDisabled, isChecked) {
  isDisabled = (!isDisabled) ? true : isDisabled;
  isChecked = (!isChecked) ? false : isChecked;

  document.getElementById(elementID).disabled = isDisabled;
  document.getElementById(elementID).checked = isChecked;
}
  
function setCheckedElementById(aElementID, aValue) {
  var retVal = document.getElementById(aElementID)

  retVal.checked = aValue;

  return true;
}  

function setPrefsElementById(aElementID, aPref) {
  var retVal = document.getElementById(aElementID);

  nsPreferences.setBoolPref(aPref, retVal.checked);

  return retVal.checked;
} 
