var CONSOLE_SERVICE = Components.classes['@mozilla.org/consoleservice;1'].getService(Components.interfaces.nsIConsoleService); 
//CONSOLE_SERVICE.logStringMessage("Test");
/*-----------------------------------------
  -                                       -
  -       PageStyle2Tab - Sethnakht       -
  -        sethnakht_fox@yahoo.com        -
  -                 2006                  -
  -----------------------------------------*/
  
/*
    Initialization
*/

var pagestyle2tab_isBGImageActive;
var pagestyle2tab_isFullScreenActive;
var pagestyle2tab_isActiveTabOnlyActive;
var pagestyle2tab_isActiveBlackWhite;
var pagestyle2tab_isActiveNoBlackWhite;
//var pagestyle2tab_isImageInFullScreenActive;



//============================================================
// To do on start up
//============================================================
pagestyle2tab_init();
function pagestyle2tab_init()
{
  pagestyle2tab_setIsBGImageActive ();
  pagestyle2tab_setIsFullScreenActive ();
  pagestyle2tab_setIsActiveTabOnlyActive ();
  pagestyle2tab_setIsActiveBlackWhite ();
  pagestyle2tab_setIsActiveNoBlackWhite ();
  //pagestyle2tab_setIsImageInFullScreenActive ();
  
  if (pagestyle2tab_isFullScreenActive || pagestyle2tab_isActiveTabOnlyActive)
  {
    window.addEventListener("select",  pagestyle2tab_selectTab, true);
  }
}

function pagestyle2tab_selectTab ()
{
  try {
    
    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                      .getService(Components.interfaces.nsIWindowMediator);
    const win = wm.getMostRecentWindow("navigator:browser");
    const browser = win.document.getElementById("content");
    const tabs = browser.mTabContainer.childNodes;  
    if (pagestyle2tab_isActiveTabOnlyActive)
      pagestyle2tab_setStyleForAllTab();
    else
      pagestyle2tab_setStyleForTab(tabs[browser.mTabContainer.selectedIndex]);
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_selectTab :\n"+e);
  }
}

function pagestyle2tab_setIsBGImageActive ()
{
  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  try { 
    pagestyle2tab_isBGImageActive = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isBGImageActive");
  }
  catch (e) 
  {
    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isBGImageActive", true);
    pagestyle2tab_isBGImageActive = true;
  }
}

function pagestyle2tab_setIsFullScreenActive ()
{
  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  try { 
    pagestyle2tab_isFullScreenActive = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isFullScreenActive");
  }
  catch (e) 
  {
    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isFullScreenActive", false);
    pagestyle2tab_isFullScreenActive = false;
  }
}

function pagestyle2tab_setIsActiveTabOnlyActive ()
{
  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  try { 
    pagestyle2tab_isActiveTabOnlyActive = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isActiveTabOnlyActive");
  }
  catch (e) 
  {
    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isActiveTabOnlyActive", false);
    pagestyle2tab_isActiveTabOnlyActive = false;
  }
}

function pagestyle2tab_setIsActiveBlackWhite ()
{
  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  try { 
    pagestyle2tab_isActiveBlackWhite = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isActiveBlackWhite");
  }
  catch (e) 
  {
    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isActiveBlackWhite", false);
    pagestyle2tab_isActiveBlackWhite = false;
  }
}

function pagestyle2tab_setIsActiveNoBlackWhite ()
{
  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
  try { 
    pagestyle2tab_isActiveNoBlackWhite = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isActiveNoBlackWhite");
  }
  catch (e) 
  {
    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isActiveNoBlackWhite", false);
    pagestyle2tab_isActiveNoBlackWhite = false;
  }
}

//function pagestyle2tab_setIsImageInFullScreenActive ()
//{
//  const pagestyle2tabprefs=Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
//  try { 
//    pagestyle2tab_isImageInFullScreenActive = pagestyle2tabprefs.getBoolPref("extensions.pagestyle2tab.isImageInFullScreenActive");
//  }
//  catch (e) 
//  {
//    pagestyle2tabprefs.setBoolPref("extensions.pagestyle2tab.isImageInFullScreenActive", true);
//    return true;
//  }
//};




window.addEventListener("load", function(event) { pagestyle2tab_setStyleForDocument(event.originalTarget); }, true);

function pagestyle2tab_setStyleForAllTab()
{
  if (!getTopWin())
    return;
  try{
    const browser = getTopWin().document.getElementById("content");
    const tabs = browser.mTabContainer.childNodes;
    const numtabs = browser.mTabContainer.childNodes.length;
    for (var i = 0; i < numtabs; ++i)
      pagestyle2tab_setStyleForTab(tabs[i]);
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_setStyleForAllTab :\n"+e);
  }
}

function pagestyle2tab_setStyleForTab(tab)
{
  try{
    if (!tab)
      return;
      
    var browserToTreat = tab.linkedBrowser;
    var tabboxToTreat = browserToTreat.parentNode.parentNode.parentNode ;
    
    if ((tab != tabboxToTreat.selectedTab) && pagestyle2tab_isActiveTabOnlyActive)
    {
      pagestyle2tab_resetStyle (tab, false);
      return;
    }
    
    const mywindow = tab.linkedBrowser.contentWindow;
    const bodyNode = pagestyle2tab_getFirstDocWithStyle(mywindow );
    const windowToTreat = browserToTreat.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;
    var finalbgcolor, finalbgimage = null, finalbgrepeat, finalbgposition, finalbgposition2;
    var bgcolor, bgimage, bgrepeat, fontfamily, colorstyle, finaltext;
    var i = 0;
    
    if (bodyNode == null)
    {
      if (pagestyle2tab_isActiveBlackWhite == true)
        pagestyle2tab_applyStyle(tab, "color: rgb(0, 0, 0) !important; background: rgb(255, 255, 255) !important;", "rgb(255, 255, 255)", "rgb(0, 0, 0)", tabboxToTreat, windowToTreat, "");
      else
        pagestyle2tab_resetStyle (tab, false);
        
      return;
    }
    
    finaltext = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "color" );
      
    finalbgcolor = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "background-color" );
    
    finalbgrepeat = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "background-repeat" );
  
    finalbgposition = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "overflow" );
  //  finalbgposition = bodyNode.style.background.position;
/*
//CONSOLE_SERVICE.logStringMessage (""
       +"\noverflow="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "overflow" )
       +"\nbackground-attachment="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "background-attachment" )
       +"\nbackground-position="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "background-position" )
       +"\nposition="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "position" )
       +"\nright="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "right" )
       +"\nleft="+bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "left" )
       +"\n---------------------------"
       +"\nbackground="+bodyNode.style.background
       +"\nbackgroundAttachment="+bodyNode.style.backgroundAttachment
       +"\nbackgroundColor="+bodyNode.style.backgroundColor
       +"\nbackgroundImage="+bodyNode.style.backgroundImage
       +"\nbackgroundPosition="+bodyNode.style.backgroundPosition
       +"\nbackgroundRepeat="+bodyNode.style.backgroundRepeat
);
*/
  finalbgposition = bodyNode.style.backgroundPosition;
  
  // move the bg is fixed position
  var finalbgpositionTab = finalbgposition.split(" ");
  //alert (finalbgpositionTab.length + " "+ finalbgposition);
  if (finalbgpositionTab.length > 0)
  {
    if (finalbgpositionTab[0].indexOf("px")>1)
    {
      var pos = parseInt (finalbgpositionTab[0].split("px")[0], 10);
      finalbgposition = (pos - 2) + "px";
      finalbgposition2 = (pos ) + "px";
      
      if (finalbgpositionTab.length  > 1)
      {
        finalbgposition = finalbgposition + " " + finalbgpositionTab[1];
        finalbgposition2 = finalbgposition2 + " " + finalbgpositionTab[1];
      }
    }
  }
  else
  {
    finalbgposition = "";
    finalbgposition2 = "";
  }
  
  
    // The browser set rgb(0, 0, 0) by default if no color set
    if (finaltext.indexOf("rgb(0, 0, 0)") == 0)
      finaltext = "rgb(35, 50, 35)";
    else if (finaltext.indexOf("rgb(255, 255, 255)") == 0)
      finaltext = "rgb(220, 220, 220)";
    
    // The browser set repeat by default if nothing set
    if (finalbgrepeat == "repeat")
      finalbgrepeat = null;
    
    if (pagestyle2tab_isBGImageActive == true)
    {
      var url = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyCSSValue( "background-image" );
      finalbgimage = ( url.primitiveType == CSSPrimitiveValue.CSS_URI ) ? url.getStringValue() : null;
    }
    
    // Activate "Others options"
    if ((pagestyle2tab_isActiveBlackWhite == true) && (finalbgcolor == "transparent") && (null != finalbgimage) && (finalbgimage.length == 0))
    {
      finalbgcolor = "rgb(255, 255, 255)";
    }
    
    if ((pagestyle2tab_isActiveNoBlackWhite == true)
        && (finaltext.indexOf("rgb(35, 50, 35)") == 0)
        && (finalbgcolor.indexOf("rgb(255, 255, 255)") == 0))
    {
      finalbgcolor = null;
    }
    
    /*
    //if ((null == finalbgcolor) && (null == finalbgimage))
    {
    //CONSOLE_SERVICE.logStringMessage("No style ?");
    try
    {
      var imgNode = bodyNode.ownerDocument.createElement("img");
      var ctx = imgNode.getContext("2d");
      ctx.clearRect(0, 0, 10, 10);
      ctx.save();
      ctx.scale(10, 10);
      ctx.drawWindow(content, 0, 0, 10, 10, "rgb(0,0,0)");
      ctx.restore();
    } catch (e) 
    {
    //CONSOLE_SERVICE.logStringMessage("Get the image pixel \n"+e);
    }
    }
    */
    
    var style = "";
   
    if (finalbgcolor == "transparent")
      finalbgcolor = null;
      
    if (finalbgcolor != null)
      style = "background: "+finalbgcolor+" !important;"

    if (finalbgimage != null)
    {
      style =  style + " background-image: url('"+finalbgimage+"') !important;";

      if (finalbgrepeat != null)
        style = style+"background-repeat: "+finalbgrepeat+" !important;";
      
      if (finaltext != null)
      {
        style = style+" color: "+finaltext+" !important;";
        colorstyle = " color: "+finaltext+" !important;";
      }
    }
    //CONSOLE_SERVICE.logStringMessage("style:\n"+style);
    
    if (   (finalbgcolor != null)
        && (  (finalbgimage == null)
            ||((finalbgimage != null) && (finaltext.indexOf("rgb(35, 50, 35)") == 0))
            ))
    {
      // Compute text color based on bgcolor, yes !
      // get bgcolor
      var colorR;
      var colorG;
      var colorB;
      
      if (finalbgcolor.indexOf("rgb")>-1)
      {
        var finalbgcolor2=finalbgcolor.substring (finalbgcolor.indexOf("rgb(")+4, finalbgcolor.indexOf(")"));
        colorR = finalbgcolor2.split(",")[0];
        colorG = finalbgcolor2.split(",")[1];
        colorB = finalbgcolor2.split(",")[2];
      }
      var sumRG = parseInt ( colorR, 10 ) + parseInt ( colorG, 10 );
      var sumGB = parseInt ( colorG, 10 ) + parseInt ( colorB, 10 );
      var sumRB = parseInt ( colorR, 10 ) + parseInt ( colorB, 10 );
      var sum = parseInt ( colorR, 10 ) + parseInt ( colorG, 10 ) + parseInt ( colorB, 10 );
      
      if (  ((sumRG)<40)
          ||((sumGB)<40)
          ||((sumRB)<40)
          ||((sum)<400))
      {
        style = style+" color: rgb(220, 220, 220) !important;"; 
        colorstyle = " color: rgb(220, 220, 220) !important;"; 
      }
      else
      {
        style = style+" color: rgb(35, 50, 35) !important;"; 
        colorstyle = " color: rgb(35, 50, 35) !important;"; 
      }
    }
    //CONSOLE_SERVICE.logStringMessage("style(2):\n"+style);
    
    if (style.length > 0)
    { 
      pagestyle2tab_applyStyle(tab, style, finalbgcolor, colorstyle, tabboxToTreat, windowToTreat, finalbgrepeat, "background-position: "+finalbgposition+" !important;", "background-position: "+finalbgposition2+" !important;" );
    }
    else
    {
      pagestyle2tab_resetStyle (tab, false);
    }
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_setStyleForTab\n"+e);
  }
}

function pagestyle2tab_applyStyle(tab, style, finalbgcolor, colorstyle, tabboxToTreat, windowToTreat, finalbgrepeat, finalbgposition, finalbgposition2 )
{
 //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_applyStyle=\n"+style+"\nfinalbgcolor="+finalbgcolor+"\ncolorstyle="+colorstyle+"\nfinalbgposition="+finalbgposition+"\nfinalbgposition2="+finalbgposition2);
  try{
    // Set Style on tab
    if ((tab.getAttribute("oldStyle") == "") && (tab.getAttribute("pageStyle2Tab-oldStyleSet") != true))
    {
      tab.setAttribute("oldStyle", tab.getAttribute("style"));
      tab.setAttribute("pageStyle2Tab-oldStyleSet", true);
    }
    tab.setAttribute("style", tab.getAttribute("oldStyle") + style + finalbgposition);
  //CONSOLE_SERVICE.logStringMessage(style + finalbgposition);
      
    if (((tab == tabboxToTreat.selectedTab)) && (pagestyle2tab_isFullScreenActive == true) && (windowToTreat.parentNode!=null))
    {
      var documentToTreat = windowToTreat.parentNode;
      var documentToTreat = getTopWin().document;
    
      // remove style of some themes        
      elts = documentToTreat.getElementsByTagName("toolbar");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].setAttribute("style", "-moz-appearance: none !important; background-image: none !important; background: none !important;");
      }
      elts = documentToTreat.getElementsByTagName("menubar");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].setAttribute("style", "-moz-appearance: none !important; background-image: none !important; background: none !important;");
      }
      elts = documentToTreat.getElementsByTagName("tabs");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].setAttribute("style", "-moz-appearance: none !important; background-image: none !important; background: none !important;");
      }
      
      
      // Set the style
      documentToTreat.getElementById("navigator-toolbox").setAttribute("style", style + finalbgposition2);  
 
      if (finalbgrepeat != null)
        documentToTreat.getElementById("content").setAttribute("style", "-moz-appearance: none !important; background: "+finalbgcolor+" !important; "+finalbgposition2+colorstyle);
      else
        documentToTreat.getElementById("content").setAttribute("style", style + finalbgposition2);
      try
      {
        documentToTreat.getElementById("status-bar").setAttribute("style", "background: "+finalbgcolor+" !important; "+colorstyle);
        documentToTreat.getElementById("statusbar-display").setAttribute("style", "-moz-appearance: none !important; background: "+finalbgcolor+" !important; "+colorstyle);
        documentToTreat.getElementById("statusbar-progresspanel").setAttribute("style", "-moz-appearance: none !important;background: "+finalbgcolor+" !important; "+colorstyle);
        try
        {
          documentToTreat.getElementById("tbx-toolbar-statusbar-left").setAttribute("style", "-moz-appearance: none !important;background: "+finalbgcolor+" !important; "+colorstyle);
          documentToTreat.getElementById("tbx-toolbar-statusbar-right").setAttribute("style", "-moz-appearance: none !important;background: "+finalbgcolor+" !important; "+colorstyle);
        } catch (e) {
          //CONSOLE_SERVICE.logStringMessage("try 1b"+e);
        }
        documentToTreat.getElementById("security-button").setAttribute("style", "-moz-appearance: none !important;background: "+finalbgcolor+" !important; "+colorstyle);
        documentToTreat.getElementById("page-report-button").setAttribute("style", "-moz-appearance: none !important;background: "+finalbgcolor+" !important; "+colorstyle);
      } catch (e) {
         //CONSOLE_SERVICE.logStringMessage("try2b"+e);
      }
      documentToTreat.getElementById("FindToolbar").setAttribute("style", "-moz-appearance: none !important;  background: "+finalbgcolor+" !important; "+colorstyle);
      documentToTreat.getElementsByTagName("sidebarheader")[0].setAttribute("style", style + finalbgposition2);
      documentToTreat.getElementById("sidebar").setAttribute("style", style + finalbgposition2);
      var elts = documentToTreat.getElementsByTagName("toolbarbutton");
      var eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].setAttribute("style", "-moz-appearance: none !important;" + colorstyle);
      }
      
      try // In a specific try/catch if nay extension remove items....
      {
        documentToTreat.getElementById("file-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("edit-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("view-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("go-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("bookmarks-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("tools-menu").setAttribute("style", colorstyle);
        documentToTreat.getElementById("helpMenu").setAttribute("style", colorstyle);
        /*
        documentToTreat.getElementById("file-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("edit-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("view-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("go-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("bookmarks-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("tools-menu").setAttribute("id", "ps2t_style");
        documentToTreat.getElementById("helpMenu").setAttribute("id", "ps2t_style");*/
      } catch(e) {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_applyStyle II\n"+e);
    }
    }
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_applyStyle"+e);
  }
}

function pagestyle2tab_setStyleForDocument(doc)
{
  try{
    //============================================================
    // Localize Description on start up
    //============================================================
/*
    var mpcLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{84b30000-62f6-364b-eba5-2e5e2061d7e6}.");
    var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
    str.data = document.getElementById("bundle_pagestyle2tab").getString("pageStyle2TabDescription");
    mpcLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str );
*/


    var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
    var e = wm.getEnumerator("navigator:browser");
    while (e.hasMoreElements()) {
      var win = e.getNext();
      if (!(win instanceof Components.interfaces.nsIDOMWindow))
        continue;
      if (win) {  
        var tabbrowser = win.document.getElementById("content");
        var l = tabbrowser.browsers.length;
        for (var i = 0; i < l; i++) {
          var tab = tabbrowser.mTabContainer.childNodes[i];    
          if (tab.linkedBrowser.contentWindow.document == doc)
            return pagestyle2tab_setStyleForTab (tab);
        }
      }
    }
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_setStyleForDocument :\n"+e);
  }
  return null;
}

// Gets all the documents from the current page
function pagestyle2tab_getFirstDocWithStyle(frame)
{
  try
  {
      const bodyNode = frame.document.getElementsByTagName("body")[0];
      if (bodyNode != null)
      {
        //search for style 
        var finalbgcolor = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyValue ( "background-color" );
        if (finalbgcolor == "transparent") finalbgcolor = null;
        var url = bodyNode.ownerDocument.defaultView.getComputedStyle( bodyNode, '' ).getPropertyCSSValue( "background-image" );
        var finalbgimage = ( url.primitiveType == CSSPrimitiveValue.CSS_URI ) ? url.getStringValue() : null;
        if ((null != finalbgcolor) || (null != finalbgimage))
            return bodyNode;
      }
        
      const framesList = frame.frames;
      const eltsnum = framesList.length;
      // Loop through the frames
      for(var i = 0; i < eltsnum; i++)
      {
        //check if frame is visible
        if ((0 == framesList[i].innerHeight) || (0 == framesList[i].innerWidth ))
          continue;
        const result = pagestyle2tab_getFirstDocWithStyle(framesList[i]);
        if (result != null)
          return result;
      }
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_getFirstDocWithStyle :\n"+e);
  }
  return null;
}

function pagestyle2tab_resetStyle (tab, force)
{
  //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_resetStyle");
  try
  {
    if (!tab)
      return;

    // reset style on TAB
    tab.removeAttribute("style");
    if (tab.getAttribute("pageStyle2Tab-oldStyleSet") == true)
      tab.setAttribute("style", tab.getAttribute("oldStyle"));

    // reset style on WINDOW
    var browserToTreat = tab.linkedBrowser;
    var tabboxToTreat = browserToTreat.parentNode.parentNode.parentNode;
    var windowToTreat = browserToTreat.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode.parentNode;

    if (  (((tab == tabboxToTreat.selectedTab)) && pagestyle2tab_isFullScreenActive && windowToTreat)
        || force)
    {
      var documentToTreat = browserToTreat.document;
      var documentToTreat = getTopWin().document;
      
      //CONSOLE_SERVICE.logStringMessage("documentToTreat("+documentToTreat.nodeName+")="+documentToTreat);
      documentToTreat.getElementById("navigator-toolbox").removeAttribute("style");
      documentToTreat.getElementById("content").removeAttribute("style");  
      try
      {
        documentToTreat.getElementById("status-bar").removeAttribute("style");
        documentToTreat.getElementById("statusbar-display").removeAttribute("style");
        documentToTreat.getElementById("statusbar-progresspanel").removeAttribute("style");
        try
        {
         documentToTreat.getElementById("tbx-toolbar-statusbar-left").removeAttribute("style");
         documentToTreat.getElementById("tbx-toolbar-statusbar-right").removeAttribute("style");
        } catch (e) {  
           //CONSOLE_SERVICE.logStringMessage("error try 1");
        }
        documentToTreat.getElementById("security-button").removeAttribute("style");
        documentToTreat.getElementById("page-report-button").removeAttribute("style");
      } catch (e) {  
         //CONSOLE_SERVICE.logStringMessage("error try 2");
      }
      documentToTreat.getElementById("FindToolbar").removeAttribute("style");    
      documentToTreat.getElementsByTagName("sidebarheader")[0].removeAttribute("style");
      documentToTreat.getElementById("sidebar").removeAttribute("style");
      var elts = documentToTreat.getElementsByTagName("toolbarbutton");
      var eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].removeAttribute("style");
      } 

      // reset style of some themes
      
      elts = documentToTreat.getElementsByTagName("toolbar");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].removeAttribute("style");
      }
      elts = documentToTreat.getElementsByTagName("menubar");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].removeAttribute("style");
      }
      elts = documentToTreat.getElementsByTagName("tabs");
      eltsnum = elts.length;
      for (var i = 0; i < eltsnum; ++i)
      {
        elts[i].removeAttribute("style");
      }
      
      try // In a specific try/catch if nay extension remove items....
      {
        documentToTreat.getElementById("file-menu").removeAttribute("style");
        documentToTreat.getElementById("file-menu").removeAttribute("style");
        documentToTreat.getElementById("edit-menu").removeAttribute("style");
        documentToTreat.getElementById("view-menu").removeAttribute("style");
        documentToTreat.getElementById("go-menu").removeAttribute("style");
        documentToTreat.getElementById("bookmarks-menu").removeAttribute("style");
        documentToTreat.getElementById("tools-menu").removeAttribute("style");
        documentToTreat.getElementById("helpMenu").removeAttribute("style");
        /*
        documentToTreat.getElementById("file-menu").removeAttribute("id");
        documentToTreat.getElementById("edit-menu").removeAttribute("id");
        documentToTreat.getElementById("view-menu").removeAttribute("id");
        documentToTreat.getElementById("go-menu").removeAttribute("id");
        documentToTreat.getElementById("bookmarks-menu").removeAttribute("id");
        documentToTreat.getElementById("tools-menu").removeAttribute("id");
        documentToTreat.getElementById("helpMenu").removeAttribute("id");
        */
      } catch(e) {}
    }
  }
  catch(e)
  {
    //CONSOLE_SERVICE.logStringMessage("pagestyle2tab_resetStyle\n"+e);
  }
}

function registerpagestyle2tab_urlChangeListener()
{
  window.getBrowser().addProgressListener(pagestyle2tab_urlChangeListener, Components.interfaces.nsIWebProgress.NOTIFY_ALL);
}

function unregisterpagestyle2tab_urlChangeListener()
{
  window.getBrowser().removeProgressListener(pagestyle2tab_urlChangeListener);
}
window.addEventListener("load",registerpagestyle2tab_urlChangeListener,false);
window.addEventListener("unload",unregisterpagestyle2tab_urlChangeListener,false);

var pagestyle2tab_urlChangeListener =
{
  timerRef : null,
  
  onStateChange:function(aProgress,aRequest,aFlag,aStatus)
  {
    try{
      // don't do anything if it's not the TOP window
      if (getTopWin()!=window)
        return;
    
      var tab = window.getBrowser().mTabBox.selectedTab; 
      var mywindow = tab.linkedBrowser.contentWindow;
      
      if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_START)
      { 
        // remove style of tab from previous load
        pagestyle2tab_resetStyle (tab, false);
        
        // add a timer to set style during load
        this.timerRef = window.setTimeout(function () {pagestyle2tab_setStyleForDocument(mywindow.document);}, 3000);
      }   
      if (aFlag & Components.interfaces.nsIWebProgressListener.STATE_STOP)
      {
        // remove timer if not yet fired
        window.clearTimeout(this.timerRef);
        // used for history back/next
        
        pagestyle2tab_setStyleForDocument(mywindow.document);
      }
    }
    catch(e)
    {
      //CONSOLE_SERVICE.logStringMessage("onStateChange :\n"+e);
    }
    return;
  },
  onLocationChange:function (aWebProgress, aRequest, aLocation){},
  onProgressChange:function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress){},
  onStatusChange:function (aWebProgress, aRequest, aStatus, aMessage) {}, 
  onSecurityChange:function (aWebProgress, aRequest, aState) {},
  onLinkIconAvailable:function(aBrowser){},

  QueryInterface : function(aIID)
  {
    if (aIID.equals(Components.interfaces.nsIXULBrowserWindow))
      return this;
    throw Components.results.NS_NOINTERFACE;
  }
} 
