/**
 * Author   : Davide Ficano
 * Date     : 27-Jul-07 Allow to access to hiddenDOMWindow using singletons
 */

var viewSourceWithFactory = {
    prefs : null,
    cleaner : null,

    // This method must be invoked by caller
    loadSubScripts : function(appShell) {
        var dependentScripts = [
             "chrome://viewsourcewith/content/globalObjectFactory.js",
             "chrome://viewsourcewith/content/common.js",
             "chrome://viewsourcewith/content/commonres.js",
             "chrome://viewsourcewith/content/keyData.js",
             "chrome://viewsourcewith/content/urlMapperData.js",
             "chrome://viewsourcewith/content/prefs.js",
             "chrome://viewsourcewith/content/tempCleaner.js" ];

        var scriptLoader = appShell.hiddenDOMWindow.Components
            .classes["@mozilla.org/moz/jssubscript-loader;1"]
            .getService(Components.interfaces.mozIJSSubScriptLoader);

        for (var i = 0 ; i < dependentScripts.length; i++) {
            scriptLoader.loadSubScript(dependentScripts[i]);
        }
    },

    getPrefsInstance: function() {
        if (viewSourceWithFactory.prefs == null) {
            var prefs = new ViewSourceWithPrefs();

            try {
                prefs.readPrefs(null);
            } catch (err) {
                ViewSourceWithCommon.log("viewSourceWithFactory: Error while opening config file: " + err);
            }
            // Update instance object only at end otherwise
            // after first installation the value is null
            viewSourceWithFactory.prefs = prefs;
        }

        return viewSourceWithFactory.prefs;
    },
    
    getTempCleaner: function() {
        if (viewSourceWithFactory.cleaner == null) {
            var cleaner = new ViewSourceWithTempCleaner();

            // Update instance object only at end otherwise
            // after first installation the value is null
            viewSourceWithFactory.cleaner = cleaner;
        }

        return viewSourceWithFactory.cleaner;
    }
}

