/**  buildLinkChunk( oValues )
	Author Yan, George Dunham

	Args:	 oValues
	Returns: sLinkChunk,
	Scope:	 public
	Called:	 By any process wanting a button Link Chunk
	Purpose: To build a proper escaped button link data. The calling
		 process is responsible to add the prefix and suffix
		 TODO:
**/
custombuttons.buildLinkChunk = function ( oValues ) //{{{
{
	var sSepString = CB2const.bFieldSepNew;
	var sLinkChunk = '';
	if ( this.isPref( CB2const.sButtonLinkMethod ) ){
		if ( this.getPrefs( CB2const.sButtonLinkMethod ) ) {
			sSepString = CB2const.bFieldSep
		}// End if ( this.getPrefs( CB2const.sButtonLinkMethod ) )
	} // End if ( this.isPref( CB2const.sButtonLinkMethod ) )
	if ( sSepString == CB2const.bFieldSep ) {
		sLinkChunk =	escape(oValues.name +
					sSepString + oValues.image +
					sSepString + this.fixField( oValues.code ) +
					sSepString + this.fixField( oValues.initCode+'//...' ) )
	}
	else {
		sLinkChunk =	escape(oValues.name +
					sSepString + oValues.image +
					sSepString + oValues.code +
					sSepString + oValues.initCode+'//...')
	} // End if ( sSepString == CB2const.bFieldSep )
	return sLinkChunk;
}; //}}} End Method buildLinkChunk( oValues )


/**  createLinks( aType, [button] )
	Author Yan, George Dunham

	Args:	 aType
		 [button]
	Returns: Nothing - Stuffs the clipboard with the specified link
	Scope:	 public
	Called:	 By the button's context menu
		 The calling process must pass the type link requested
		 Use the constants to specify
			CB2const.nClipbrd
			CB2const.nHyper
			CB2const.nBBCode
	Purpose: To
		 TODO:
**/
custombuttons.createLinks = function ( aType, button ) //{{{
{
	var Button = ( button )? button : document.popupNode;	// Modified 8/23/2007
	var num = this.getNumber(Button.id);
	var values = this.getButtonParameters2(num);
	var sLinkChunk = this.buildLinkChunk( values );
	var uri = '';
	switch ( aType )
	{
	case CB2const.nClipbrd :
		uri='custombutton://' +
		sLinkChunk;
		break;
	case  CB2const.nHyper :
		uri =  '<a href="custombutton://' + sLinkChunk + '" title="' + unescape(values.name);
		uri += '"><img alt="' + unescape(values.name) + '" src="' + unescape(values.image);
		uri += '" border="0" style="margin: 0 6px;" />' + unescape(values.name) + '</a>';
		break;
	case  CB2const.nBBCode :
		uri = "[cb=custombutton://";
		uri += sLinkChunk +',';
		uri += unescape(values.image) + "]" + unescape(values.name) + "[/cb]";
		break;
	}// End switch ( aType )
	gClipboard.write(uri);
	return uri;
}; //}}} End Method createLinks( aType )
/**  fixField( s )
	Author Yan, George Dunham

	Args:	 s
	Returns: sRet,
	Scope:	 public
	Called:	 From any external process which must pass an unescaped string
		 and accept a string in return.
	Purpose: Expand a "][" sequence to "] [" in order to hack around
		 the button split issue.
		 TODO:
**/
custombuttons.fixField = function ( s ) //{{{
{
	var sRet = s;
	if (s.indexOf(CB2const.bFieldSep) > -1 ){
		sRet = s.replace(/\]\[/g,CB2const.bFieldSepHack);
	}
	return sRet;
}; //}}} End Method fixField( s )


/**  cpyButtonName(  )
	Author Yan, George Dunham

	Args:
	Returns: Nothing - Stuffs the clipboard with the data
	Scope:	 private
	Called:	 From the Custombuttons context menu.
	Purpose: Stuff the clipboard with the copy Button Name data
		 and pop a msgBox with the data.
		 TODO:
**/
custombuttons.cpyButtonName = function (  ) //{{{
{
	var Button = document.popupNode;
	var strstat = document.popupNode.getAttribute('status');
	strstat = (strstat.length > 0)? cb2String.sOvrlyCB2cpyButStat.replace(/%s/gi,strstat) : cb2String.sOvrlyCB2cpyButStatNSet;
	var strver = document.popupNode.getAttribute('version');
	strver = (strver.length > 0)? cb2String.sOvrlyCB2cpyButVer.replace(/%s/gi,strver) : cb2String.sOvrlyCB2cpyButVerNSet;
	var str = Button.label +' '+ strver +' '+ strstat;
	gClipboard.write(str);
	var cbn = createMsg(cb2String.sOvrlyCB2cpyButNamVer.replace(/%s/gi,Button.label));
	cbn.aMsg(gClipboard.read());
}; //}}} End Method cpyButtonName(  )
/**  updateButton(  )
	Author George Dunham

	Args:
	Returns: Nothing
	Scope:	 private
	Called:	 From the Custombuttons context menu.
	Purpose: Update an existing button with new field data.
		 TODO:
**/
custombuttons.updateButton = function ( oBtn ) //{{{
{
	var bValue = this.oSplitButtonURI(gClipboard.read());
	if ( typeof bValue != CB2const.BOOLEAN ){				// Success
		var oButton = ( oBtn )? oBtn : document.popupNode;
		if ( oBtn || this.confirmBox( cb2String.sOvrlyUpdate.replace(/%s/gi, oButton.label ), cb2String.sOvrlyUpdateConfirm.replace(/%s/gi, oButton.label ).replace(/%y/gi, bValue.name ), cb2String.sOvrlyUpdateButton, cb2String.sOvrlyCancelButton ) ) {
			var num = this.getNumber(oButton.id);
			// var values = this.convButFieldsToObj( bValue );
			this.setButtonParameters( num, bValue );
		} // End if ( this.confirmBox() )
	} // Endif ( typeof bValue != CB2const.BOOLEAN )
}; //}}} End Method updateButton(  )
/**  bookmarkButton(  )
	Author George Dunham

	Args:
	Returns: Nothing
	Scope:	 private
	Called:
	Purpose: Allows one to save a button as a bookmark
		 TODO:
**/
custombuttons.bookmarkButton = function (  ) //{{{ Updated 8/23/2007
{
	var Button = document.popupNode;
	this.createLinks( CB2const.nClipbrd, Button );
	// UPDATED: 10/10/2007 to accomodate Minefield Places
	if ( this.bFFmode || this.compareVersion( this.gAppVersion(), CB2const.sCbMFVersion ) > -1 ) {
		PlacesCommandHook.bookmarkLink(PlacesUtils.bookmarksRootId, gClipboard.read(), Button.label );
	}
	else {
		BookmarksUtils.addBookmark(gClipboard.read(), Button.label );
		// alert('here');
	}
}; //}}} End Method bookmarkButton(  )


/**  homepageButton(  )
	Author Lou Cypher, m435tr0d, George Dunham

	Args:
	Returns: Nothing
	Scope:	 private
	Called:	 By custombuttons contexr menu.
	Purpose: To Open the buttons homepage
		 TODO:
**/
custombuttons.homepageButton = function (  ) //{{{
{
	openUILink(document.popupNode.getAttribute('homepage'));
}; //}}} End Method homepageButton(  )


/**  Object gClipboard
 Author:	George Dunham aka: SCClockDr
 Date:		2007-02-11

 Scope:		Public
 Properties:
		sRead - An array which holds the local clipboard data.
 Methods:
		write - Stuffs data into the system clipboard.
		clear - Clears the system clipboard.
		Clear - Clears the local clipboard.
		read - Retrieves the system clipboard data.
		Write - Stuffs data into the local clipboard.
		Read - Retrieves the local clipboard data.
 Purpose:	1. Provide a simple means to access the system clipboard
		2. Provid an alternate clipboard for storing a buffer of
			 copied strings.
 TODO:		1. gClipboard.ClearHist sets sRead.length to 0
 TODO:		2. gClipboard.History offers a context menu of up to 10 past clips to paste
 TODO:		3. gClipboard.SystoI adds the sys Clipboard to the internal clipboard

**/
var gClipboard = { //{{{
	// Properties:
	sRead:new Array(),
	// Methods
	/**  write( str )

	 Scope:		public
	 Args:		sToCopy
	 Returns:	Nothing
	 Called by:	1. Any process wanting to place a string in the clipboard.
	 Purpose:	1.Stuff and Retrieve data from the system clipboard.
	 UPDATED:	9/18/2007 Modified to conform to the MDC suggested process.
	 TODO:		1.
	**/
	write:function ( sToCopy ) //{{{
	{
		if (sToCopy != null){		  			// Test for actual data
			var str  = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
			str.data = sToCopy;
			var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
			trans.addDataFlavor("text/unicode");
			trans.setTransferData("text/unicode", str, sToCopy.length * 2);
			var clipid = Components.interfaces.nsIClipboard;
			var clip   = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid);
			clip.setData(trans, null, clipid.kGlobalClipboard);
		} // End if (str != null)
	}, //}}} End Method write( str )

	/**  clear(  )

	 Scope:		public
	 Args:
	 Returns:	Nothing
	 Called by:
			1. Any process wanting to clear the clipboard
	 Purpose:
			1. Clear the system cllipboard
	 TODO:
			1.
	**/
	clear:function (  ) //{{{
	{
		gClipboard.write('');
	}, //}}} End Method clear(  )
	/**  Clear(  )

	 Scope:		public
	 Args:
	 Returns:	Nothing
	 Called by:
			1. Any process wanting to clear the local clipboard
	 Purpose:
			1. Clear the local cllipboard
	 TODO:
			1.
	**/
	Clear:function (  ) //{{{
	{
		this.sRead[0] = '';
	}, //}}} End Method Clear(  )
	/**  read(  )

	 Scope:		public
	 Args:
	 Returns:	sRet
	 Called by:
			1.
	 Purpose:
			1.
	 TODO:
			1.
	**/
	read:function (  ) //{{{
	{
		var str       = new Object();
		var strLength = new Object();
		var pastetext = null;
		var clip  = Components.classes["@mozilla.org/widget/clipboard;1"].getService(Components.interfaces.nsIClipboard);
		if (!clip) return pastetext;
		var trans = Components.classes["@mozilla.org/widget/transferable;1"].createInstance(Components.interfaces.nsITransferable);
		if (!trans) return pastetext;
		trans.addDataFlavor("text/unicode");
		clip.getData(trans, clip.kGlobalClipboard);
		trans.getTransferData("text/unicode", str, strLength);
		if (str) str       = str.value.QueryInterface(Components.interfaces.nsISupportsString);
		if (str) pastetext = str.data.substring(0, strLength.value / 2);
		return pastetext;
	}, //}}} End Method read(  )

	/**  Write( str )

	 Scope:		public
	 Args:		str
	 Returns:	Nothing
	 Called by:
			1.
	 Purpose:
			1.
	 TODO:
			1.
	**/
	Write:function ( str ) //{{{
	{
		this.sRead[0] = str;
	}, //}}} End Method Write( str )

	/**  Read(  )

	 Scope:		public
	 Args:
	 Returns:	sRet
	 Called by:
			1.
	 Purpose:
			1.
	 TODO:
			1.
	**/
	Read:function (  ) //{{{
	{
		var sRet = this.sRead[0];
		return sRet;
	} //}}} End Method Read(  )

}; //}}} End Object gClipboard


/*  ===============    Add (Create) New Button Routine   ===============  */
/**  createButton( name, img, code, Icode, btn )
 Author:	George Dunham aka: SCClockDr

 Scope:		public
 Args:		name - Button label field
		img - Button img field
		code - Button code field
		Icode - Button Icode field
		btn - Button Object
 Returns:	Nothing
 Called by:	1. Any process that wants to create a button
		2. It must pass name, img, code, & Icode
		3. If btn is not passed the popupNode ia assumed
 Purpose:
		1.
 UPDATED: 10/31/2007 To stabilize toolbar decoration issues
**/
function createButton( name, img, code, Icode, oBtn ) //{{{
{
	var nowButton = ( oBtn )? oBtn : document.popupNode;
	var values=custombuttons.convButFieldsToObj( [name, img, code, Icode] );

	var toolbar=nowButton.parentNode;

	var newNum=custombuttons.min_button_number();
	var newButton=custombuttons.createButton(newNum,values);
	var newButton2=custombuttons.createButton(newNum,values);
	var newButtonId=newButton.id;

	// we add into palette
	custombuttons.addToPalette(newButton2);

	// in toolbar
	var aBefore=nowButton.nextSibling;
	custombuttons.insertToToolbar(toolbar,newButton,aBefore);
	// Reset the button's toolbar and make permanent
	custombuttons.commitTbChanges( toolbar, newButton.id, nowButton.id );
} //}}} End Function createButton( name, img, code, Icode, btn )


/**  gQuot( evt, cButton )
 Author:	George Dunham aka: SCClockDr

 Scope:		global
 Args:		evt -
		cButton -
 Returns:	Nothing
 Called by:	1. Any custombuttons-button.
 Purpose: 	1. Handle mouse click events.
 TODO:		1.
**/
var gQuot = function( evt, cButton ) //{{{
{
	custombuttons.gQuot.mHandler( evt, cButton );
} //}}} End Function gQuot( evt, cButton )
/**  gShowPopup( node )
 Author:	George Dunham aka: SCClockDr

 Scope:		global
 Args:		node -
 Returns:	Nothing
 Called by:	1. ???
 Purpose: 	1. Display the Custom Buttons² context menu.
		2. No button author intervention expected.
 TODO:		1.
**/
var gShowPopup = function( node ) //{{{
{
	custombuttons.gQuot.gShowPopup( node );
}; //}}} End gShowPopup( node )
/**  createMsg( [title] )
 Author:	George Dunham aka: SCClockDr

 Scope:		global
 Args:		title - Optional Title to init the object with.
 Returns:	Msg
 Called by:	1. Any process wanting to instance this message object.
 Purpose: 	1. Create a message object and return it to the caller process.
 How it works:	gMsg uses the constructor method to create an object gMsg
 Setup:		MyObj = new gMsg();
 Use:		MyObj.aMsg('Any string', ['Optional Title']);
 TODO:		1.
**/
var createMsg = function( title ) //{{{
{
	/**  Object Msg
	 Author:	George Dunham aka: SCClockDr

	 Scope:		Public
	 Properties:	prompts - nsIPromptService
			check - Provides a check box if value = true.
			sTitle - Retains the default/assigned title for the
				 Dialog box.
	 Methods:	aMsg - Displays the dialog box.
	 Purpose:	1. Provide a better means to alert the operator.
	 TODO:		1.
	**/
	var Msg = { //{{{
		// Properties:
		prompts:Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
				.getService(Components.interfaces.nsIPromptService),
		check:{value: false},
		sTitle:'Custom Buttons²',
		button:false,
		// Methods
		/**  aMsg( str, [title] )

		 Scope:		global
		 Args:		str - String to display
				title - Optional title of the dialog
		 Returns:	Nothing
		 Called by:	1. Any process which has the aMsg object
					 available
		 Purpose: 	1. Present a confirm dialog.
		 TODO:		1.
		**/
		aMsg:function ( str, title ) //{{{
		{
			if (typeof title == 'string'){this.sTitle = title}
			var flags = this.prompts.BUTTON_POS_0 * this.prompts.BUTTON_TITLE_IS_STRING;
			var button = this.prompts.confirmEx(null, this.sTitle, str, flags, cb2String.sOvrlyContinueButton, "", "", '', this.check);
		}  //}}} End Method aMsg( str, [title] )


	}; //}}} End Object Msg
	if (typeof title == 'string'){Msg.sTitle = title}
	return Msg;
}; //}}} End createMsg( [title] )

var createDebug = function(bttn) {
	var gMsgx = {
	prompts	: Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
			.getService(Components.interfaces.nsIPromptService),
	strs	: new Array(),
	sdebug	: '       '+cb2String.sOvrlysdeBugString+'\n\n',
	swarn	: '   '+cb2String.sOvrlydeBugWarn+'\n\n',
	strerr	: new Array([cb2String.sOvrlyUnkError]),
	sVer	: '',
	mode	: 0,
	check	: {value: false },                  // default the checkbox to false
	bugon	: {value: true },
	bugonlp	: {value: true },
	Func	: '',
	Name	:'',
/*----------------------------------------------------
	Method .finit(bttn)
	installs version and btn label into object
-------------------------------------------------------*/
	finit	: function(btn) {
			this.sVer = btn.getAttribute("version");
			this.Name = btn.label;
			this.ID   = btn.getAttribute('id')
			this.title = cb2String.sOvrlyPromptButton+' - ['+this.Name+'] '+cb2String.sOvrlyVerAbbrev+this.sVer
		},
/*----------------------------------------------------
	Method .setErr(estr)
	Pushes the next error (estr) into the error array
-------------------------------------------------------*/
	setErr	: function (estr) {
			this.strerr.push([estr]);
		},
/*----------------------------------------------------
	Method .bug(str)
	Displays the DeBug confirmEx box with str
-------------------------------------------------------*/
	bug	: function (str){
			var flags = this.prompts.BUTTON_POS_0 * this.prompts.BUTTON_TITLE_IS_STRING +
						this.prompts.BUTTON_POS_1 * this.prompts.BUTTON_TITLE_IS_STRING;
			//var button will contain the index of the button pressed,
			// 0, 1, or 2.
			var xstr = ''
			this.bugonlp.value = true;
			if (this.bugon.value) {
				xstr = this.sdebug+str;
				var button = this.prompts.confirmEx(null, this.title, xstr, flags, cb2String.sOvrlyContinueButton, cb2String.sOvrlyStopDebugButton, "", '', this.bugon);
			if (button == 1) {this.bugon.value = false}
			}
		},
/*----------------------------------------------------
	Method .bugloop(str)
	Displays the DeBug confirmEx box with str
	Used in loop operation debuging
-------------------------------------------------------*/
	bugloop	: function (str){
			var flags = this.prompts.BUTTON_POS_0 * this.prompts.BUTTON_TITLE_IS_STRING +
						this.prompts.BUTTON_POS_1 * this.prompts.BUTTON_TITLE_IS_STRING  +
						this.prompts.BUTTON_POS_2 * this.prompts.BUTTON_TITLE_IS_STRING;
			// This value of flags will create 3 buttons. The first will be "Save", the
			// second will be the value of aButtonTitle1, and the third will be "Cancel"
			// The checkbox will be hidden, and button will contain the index of the button pressed,
			// 0, 1, or 2.
			var xstr = ''
			if (this.bugonlp.value && this.bugon.value) {
				xstr = this.sdebug+str;
				var button = this.prompts.confirmEx(null, this.title, xstr, flags, cb2String.sOvrlyContinueButton, cb2String.sOvrlyStopDebugButton, cb2String.sOvrlyFinishLoopButton, '', this.bugon);
			if (button >= 1 ) {this.bugonlp.value = false}
			if (button == 1 ) {this.bugon.value = false}
			}
		},
/*----------------------------------------------------
	Method .warn(str)
	Displays the Warning alert box with str
-------------------------------------------------------*/
	warn	: function (str){
				var xstr = this.swarn + str;
				this.prompts.alert( null, this.title, xstr );
			},
/*----------------------------------------------------
	Method .err(nerr)
	Displays the Error alert box with Error string indexed by nerr
-------------------------------------------------------*/
	err	: function (nerr){
			if (nerr >= 0 && nerr <= this.strerr.length ) {
				var xstr = cb2String.sOvrlyMsgError + ' ' + nerr + ' '+this.strerr[nerr];
				this.prompts.alert( null, this.title, xstr );
			}
			else {
				var ystr = cb2String.sOvrlyMsgError + ' ' + nerr+' ??? '
					+ ' '+cb2String.sOvrlyerrOoR
				this.prompts.alert ( null, this.title, ystr);
				/* This will be the basis for a future revamp of the error method.
				var msg='Custom Buttons error.]'
				+'[ Event: '+uEvent+']'
				+'[ Button name: '+this.Name+']'
				+'[ Version: '+this.sVer+']'
				+'[ Button ID: '+this.ID+']'
				+'[ '+e;
				*/
			}
		}
	}
	gMsgx.finit(bttn);
	return gMsgx;
}
/*  ===============     Remove Context Item Statement    ===============  */
removeContextItem("context-custombuttons-viewcodes");
/**  createContextMenuItem( mId )
 Author:	George Dunham aka: SCClockDr
 Scope:		private
 Args:		mId -
 Returns:	mItem -
 Called by:	1. custombuttons.init()
 Purpose: 	1. Create the view Codes menu item.
 TODO:		1.
**/
function createContextMenuItem( mId ) //{{{
{
	if(typeof custombuttons != "object") return null;
	var mItem = document.createElement("menuitem");
	mItem.id = mId;
	mItem.setAttribute("label", cb2String.sOvrlyViewCodesLabel);
	mItem.setAttribute("oncommand", "custombuttons.viewCodes()");
	mItem.style.listStyleImage = cb2String.sOvrlyCb2LogoVc;
	mItem.setAttribute("accesskey", cb2String.sOvrlyaccessKeyV);
	return mItem;
} //}}} End Function createContextMenuItem( mId )
/**  removeContextItem( mId )
 Author:	George Dunham aka: SCClockDr
 Scope:		private
 Args:		mId -
 Returns:	Nothing
 Called by:	1. removeContextItem statment once the extension is initalized.
 Purpose: 	1.
 TODO:		1.
**/
function removeContextItem( mId ) //{{{
{
	var menuItem=document.getElementById(mId);
	while (menuItem!=null){
		menuItem.parentNode.removeChild(menuItem);
		menuItem=document.getElementById(mId);
	}
} //}}} End Function removeContextItem( mId )
/*  ===============         The Rest of the Stuff        ===============  */


custombuttons.createButtonMF = function( oValues ) //{{{
{
	let nRet = -1;
	// UPDATED: 10/10/2007 to accomodate Minefield Places
	if (  this.bFFmode || this.compareVersion( this.gAppVersion(), CB2const.sCbMFVersion ) > -1 ) {
		nRet = 0;
		if ( this.confirmBox( cb2String.sOvrlyInstall.replace(/%s/gi, oValues.name), cb2String.sOvrlyInstallConfirm.replace(/%s/gi, oValues.name), cb2String.sOvrlyInstallButton, cb2String.sOvrlyCancelButton ) ) {
			var toolbar=document.getElementById( 'nav-bar' );
			var newNum=this.min_button_number();
			var newButton=this.createButton( newNum, oValues );
			var newButton2=this.createButton( newNum, oValues );
			custombuttons.addToPalette( newButton2 );
			this.insertToToolbar( toolbar, newButton );
			newButton.disabled = true;
			newButton.hidden = true;
			newButton.setAttribute('initialized',false);
			// UPDATED: 10/10/2007 to accomodate Minefield Places
			document.getElementById("cmd_CustomizeToolbars").setAttribute( 'disabled', "true" );
			nRet = 1;
			var str=cb2String.sButtonAddedAlert + cb2String.sButtonAddedAlertMF
			// UPDATED: 10/10/2007 Bug Fix + oV - v
			var Ttl=cb2String.sButtonAddedTitle.replace(/%s/gi,oValues.name)
			this.alertBox(Ttl, str);

		} // End if ( this.confirmBox( ) )
	} // End if ( this.compareVersion( ) )
	return nRet
}; //}}} End Function createButton( name, img, code, Icode, btn )

	/**  getCbContextObj( oBtn )

	 Scope:		global
	 Args:		oBtn -
	 Returns:	oRet
	 Called by:	1. Any Custom Buttons² Button
	 Purpose: 	1. Maintain and manipilate the Custom Buttons² Context
				 Menu
	 NOTE:		1. Must be named this.mObj within the button's
				 Initialization Code field
			2. The Object is presented to the button as Initalized,
				 no setup required.
			3. View usage documentation within the object's comments
	**/
custombuttons.getCbContextObj = function ( oBtn ) //{{{
	{
/**  Object mObj
		 Author:	SCClockDr

		 Scope:		Private - Each instance of this object is unique.
				Global - It's properties and methods are available
					within the button's namedspace.
					ButtonObj.mObj.property/method()
		 Properties:	BtnIdNum - Owner's id #
				ItemIdPre - Init to "Cb2-BtnIdNum-"
				mCtxtSub - Context mode flag.
					setSub makes this true
					setPri makes this false
				oMenu - Primary Context menu Object
				nMenu - SubMenu Context menu Object
				oId - Primary Context menu id
				nId - SubMenu Context menu id
				OurCount - Counter Object used to provide the
					sequential number in the item id
				menuitems - Holds the menu child count
				aElements - Holds the menu child collection
				aItemIdx - An array of Menuitem property names
		Methods:	init - Sets the initial state and is called by
					the wrapper prior to presenting the object
					to the caller.
				setSub - Sets the Sub menu on and reduces the
					primary menu to one Custom Buttons² item
					"Custom Button" which invokes the subMenu
					If button specific Items are already in
					the primary menu they will be presented
					as well.
				setPri - Resets the Primary menu and kills the
					SubMenu. It hides any button specific
					Items appended to the primary menu.
				getItem - Retrieves an object with named
					properties. Which the user populates with
					the item data specific to their
					application. Fields not populated will not
					alter the menuitem when populated.
					Id is REQUIRED and if ommitted a default
					will be substituted. the Id's structure
					is: "Cb2-##-YourID++" Where:
						## is the button's id number
						++ is a 0 based sequential number
					Menuseparators are invoked by omitting
					the label property
				insertBefore - Inserts a menuitem to the primary
					Context menu before the menuitem specified in arg2
					Requires the populated getItem Object as an arg
					and a reference menuitem as arg 2
				insertAfter - Inserts a menuitem to the primary
					Context menu after the menuitem specified in arg2
					Requires the populated getItem Object as an arg
					and a reference menuitem as arg 2
				addItem - Prepends a menuitem to the primary
					Context menu. Requires the populated
					getItem Object as an arg.
				populate - Populated the menuitem with the data
					supplied.
				remItem - Removes the specified item (by Id) from the
					Primary Context Menu.
		 Purpose:	1. See preceding comment block
		 TODO:		1.
		**/
		var oRet =
		{
			// Properties:
			BtnIdNum:0,
			ItemIdPre:'Cb2-',
			mCtxtSub:false,
			oMenu:null,
			nMenu:null,
			oId:'',
			nId:'',
			OurCount:{},
			menuitems:0,
			aElements:[],
			listener:function(){},
			aItemIdx:['id','label','image','oncommand','command','acceltext','accesskey','allowevents',
					'autocheck','checked','crop','description','disabled','key', 'name',
					'tabindex','type','validate','value'],
			// Methods
			/**  init(   )

			 Scope:		global
			 Args:
			 Returns:	Nothing
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			init:function ( oBtn ) //{{{
			{
				var ct = this;
				ct.BtnIdNum = custombuttons.getNumber( oBtn.id );
				ct.OurCount = custombuttons.gCounter();
				ct.oMenu = document.getElementById( CB2const.sCBCtxtMenu );
				ct.nMenu = document.getElementById( CB2const.sCBCtxtMenuSub );
				ct.oId = ct.oMenu.id;
				ct.nId = ct.oMenu.id;
				ct.menuitems = ct.oMenu.childNodes.length;
				ct.aElements = ct.oMenu.childNodes;
				ct.remItem();
			}, //}}} End Method init(  )
			/**  setSub(  )

			 Scope:		global
			 Args:
			 Returns:	Nothing
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			setSub:function (  ) //{{{
			{
				var ct = this;
				ct.mCtxtSub = true;
				for ( var i = 0; i < ct.menuitems; i++) {
					if (ct.aElements.item(i).id.indexOf(CB2const.sCBCtxtMenu) > -1) ct.aElements.item(i).hidden = true;
				} // End for
				ct.aElements.item(ct.menuitems-1).hidden = false;
			}, //}}} End Method setSub(  )
			/**  setPri(  )

			 Scope:		global
			 Args:
			 Returns:	Nothing
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			setPri:function (  ) //{{{
			{
				var ct = this;
				ct.mCtxtSub = false;
				for ( var i = 0; i < ct.menuitems-1; i++) {
					ct.aElements.item(i).hidden = false;
				} // End for
				ct.aElements.item(i).hidden = true;
			}, //}}} End Method setPri(  )
			/**  getItem(  )

			 Scope:		global
			 Args:
			 Returns:	oItem
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			getItem:function (  ) //{{{
			{
				if ( this.mCtxtSub ) {
					var oItem = {
							id:'',
							label:'',
							image:'',
							oncommand:'',
							command:'',
							acceltext:'',
							accesskey:'',
							allowevents:false,
							autocheck:false,
							checked:false,
							crop:'',
							description:'',
							disabled:false,
							key:'',
							tabindex:'',
							type:'',
							validate:'',
							value:''
					}// End oItem
					return oItem;
				} // End if ( mCtxtSub )
				return null;
			}, //}}} End Method getItem(  )
			/**  insertBefore( oMenuItem )

			 Scope:		global
			 Args:		oNew - Data Object
					oChildNode - Node to insert before
			 Returns:	sRet - ItemId
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			insertBefore:function ( oNew, oChildNode ) //{{{
			{
				var ct = this;
				var sTemp = '';
				if ( !oChildNode ) {
					oChildNode = ct.oMenu.firstChild;
				} // End if ( oChildNode )
				if ( ct.mCtxtSub ) {
					var idPre = ct.ItemIdPre + ct.BtnIdNum + '-';
					var oRet = ''
					var newItem = ( oNew.label )? document.createElement('menuitem') : document.createElement('menuseparator') ;
					ct.menuitems = ct.oMenu.childNodes.length;
					ct.aElements = ct.oMenu.childNodes;
					sTemp = idPre;
					sTemp += ( oNew.id )? oNew.id : ( oNew.label )? oNew.label : 'separator';
					sTemp += ct.OurCount.inc()[0];
					oNew.id = sTemp;
					ct.populate( oNew, newItem );
					oRet = ct.oMenu.insertBefore( newItem, oChildNode );
				} // End if ( mCtxtSub )
				return oRet
			}, //}}} End Method insertBefore( oNew, oChildNode )

			/**  insertAfter( oMenuItem, oChildNode )
			 Scope:		global
			 Args:		oNew - Data Object
					oChildNode - Node to insert before
			 Returns:	sRet - ItemId
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			insertAfter:function ( oNew, oChildNode ) //{{{
			{
				var ct = this;
				var sTemp = '';
				//if ( !oChildNode ) {
					//return ct.addItem(oNew);
				//} // End if ( oChildNode )
				if ( ct.mCtxtSub ) {
					var idPre = ct.ItemIdPre + ct.BtnIdNum + '-';
					var oRef = {}
					//for (var i in ct.aElements) {
						//oRef = ( oChildNode.id == ct.aElements[i].id )? ct.aElements[i] : oRef ;
					//} // End for
					var oRet = {};
					var newItem = ( oNew.label )? document.createElement('menuitem') : document.createElement('menuseparator') ;
					ct.menuitems = ct.oMenu.childNodes.length;
					ct.aElements = ct.oMenu.childNodes;
					sTemp = idPre;
					sTemp += ( oNew.id )? oNew.id : ( oNew.label )? oNew.label : 'separator';
					sTemp += ct.OurCount.get();
					oNew.id = sTemp;
					ct.populate( oNew, newItem );
					oRet = ct.oMenu.insertBefore(newItem, oChildNode);
					ct.OurCount.inc();
				} // End if ( mCtxtSub )
				return oRet
			}, //}}} End Method insertAfter( oNew, oChildNode )

			/**  addItem( oMenuItem )

			 Scope:		global
			 Args:		oNew - Data Object
			 Returns:	sRet - ItemId
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			addItem:function ( oNew ) //{{{
			{
				var ct = this;
				var sTemp = '';
				if ( ct.mCtxtSub ) {
					var idPre = ct.ItemIdPre + ct.BtnIdNum + '-';
					var oRet = ''
					var newItem = ( oNew.label )? document.createElement('menuitem') : document.createElement('menuseparator') ;
					ct.menuitems = ct.oMenu.childNodes.length;
					ct.aElements = ct.oMenu.childNodes;
					sTemp = idPre;
					sTemp += ( oNew.id )? oNew.id : ( oNew.label )? oNew.label : 'separator';
					sTemp += ct.OurCount.inc()[0];
					oNew.id = sTemp;
					ct.populate( oNew, newItem );
					oRet = ct.oMenu.insertBefore( newItem, ct.oMenu.firstChild );

				} // End if ( mCtxtSub )
				return oRet
			}, //}}} End Method addItem( oNew )

			/**  populate( oData, mItem )

			 Scope:		private
			 Args:		oData -
					mItem -
			 Returns:	Nothing
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			populate:function ( oData, mItem ) //{{{
			{
				var ct = this;
				for (var i in ct.aItemIdx ) {
					if ( oData[ct.aItemIdx[i]] ) mItem.setAttribute( ct.aItemIdx[i], oData[ct.aItemIdx[i]] );
				} // End for
			}, //}}} End Method populate( oData, mItem )
			/**  getItemsById( id )

			 Scope:		global
			 Args:		id -
			 Returns:	aRet
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			getItemsById:function ( id ) //{{{
			{
				var aRet = [];
				var ct = this
				var cId = ( id )? id : '' ;
				var idPre = ct.ItemIdPre + ct.BtnIdNum + '-';
				cId = ( cId.indexOf( idPre ) > -1 )? cId : idPre + cId;
				ct.menuitems = ct.oMenu.childNodes.length;
				ct.aElements = ct.oMenu.childNodes;
				for ( var i = 0; i < ct.menuitems; i++) {
					if ( ct.aElements.item(i).id.indexOf( cId ) > -1 ) {
						aRet.push( ct.aElements.item(i) );
					}
				} // End for
				return aRet;
			}, //}}} End Method getItemsById( id )
			/**  getAttributeById( id, aName )

			 Scope:		global
			 Args:		id -
					aName -
			 Returns:	aRet
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			/*getAttributeById:function ( id, aName ) //{{{
			{
				var aRet = [];
				with ( this ) {
					var cId = ( id )? id : '' ;
					var idPre = ItemIdPre + BtnIdNum + '-';
					cId = ( cId.indexOf( idPre ) > -1 )? cId : idPre + cId;
					menuitems = oMenu.childNodes.length;
					aElements = oMenu.childNodes;
					for ( var i = 0; i < menuitems; i++) {
						if ( aElements.item(i).id.indexOf( cId ) > -1 ) {
							aRet.push( aElements.item(i).getAttribute( aName ) );
						}
					} // End for

				}
				return aRet;
			}, //}}} End Method getAttributeById( id, aName )*/

			/**  remItem( id )

			 Scope:		private
			 Args:		id -
			 Returns:	Nothing
			 Called by:	1.
			 Purpose: 	1.
			 TODO:		1.
			**/
			remItem:function ( id ) //{{{
			{
				var ct = this;
				var cId = ( id )? id : '' ;
				var idPre = ct.ItemIdPre + ct.BtnIdNum + '-';
				cId = ( cId.indexOf( idPre ) > -1 )? cId : idPre + cId;
				ct.menuitems = ct.oMenu.childNodes.length;
				ct.aElements = ct.oMenu.childNodes;
				for ( var i = 0; i < ct.menuitems; i++) {
					if ( ct.aElements.item(i).id.indexOf( cId ) > -1 ) {
						ct.oMenu.removeChild( ct.aElements.item(i) );
						i--;
						ct.menuitems--;
					}
				} // End for
			}  //}}} End Method remItem( id )
		}; //}}} End Object mObj
		oRet.init( oBtn );
		return oRet;
	}; //}}} End Method getCbContextObj( oBtn )


// ---------------   Event Detect   ------------------
	/**  Object gQuot
	 Author:	George Dunham aka: SCClockDr

	 Scope:		Public
	 Properties:
	 Methods:
			mHandler -
			gShowPopup -
	 Purpose:	1. Handle mouse clicks
			2. Popup the Custom Buttons² context menu
	 How it works:	  On a click the calling button is strobed via
			"this.setAttribute("onclick", "gQuot(event, this);");"
			line in its Initialization Code section. This passes
			the event and button (this) object here.
	 Execution:	1. First we check for a shift + right click if that was
				 the event we call gShowPopup(cButton) passing it the
				 button object.
			2. If not a shift + right click we proceed to check for
				 a click event called function presence pair.
				a. Testing progress down the tree till we arrive
					 at the clicked button with no extra key
					 qualifier.
				b. If that function is persent execution passes
					 to the called function within the calling
					 button. We pass the event object to the called
					 function to provide the button author the info
					 for further processing.
			3. If no matches are found then all combinations will put
				 up the menu.
	 Calls:		1. "cButton.cleftclick(evt)" calls the button object that
				 was passed function cleftclick.
				 It passes the Click event object to the button and
				 expects nothing in return.
			2. When control returns to this function we encounter
				 break and the function exits to the button's calling
				 attribute "onclick" statement.
			3. We are then done with that event.
	 UPDATED:		8/25/2007 Moved to custombuttons object
	**/
custombuttons.gQuot = { //{{{
	// Properties:
	// Methods
	/**  mHandler( evt, cButton )

	 Scope:		private
	 Args:		evt -	Mouse click event used to direct code
				execution based on the button clicked and
				any extra state keys held during the
				event.
			cButton - Button of the calling button used to
					appropriatly locate the context menu.
	 Returns:	Nothing
	 Called by:	1. Custom Buttons² buttons onclick Attribute
	 Purpose: 	1. Call the appropriate click function based on
				 the mouse button clicked and its modifiers.
	 TODO:		1.
	**/
	mHandler:function ( evt, cButton ) //{{{
	{
		cButton = ( cButton )? cButton : evt.target ;
		var lNaked = (!evt.shiftKey && !evt.ctrlKey && !evt.altKey)
		if( evt.target.disabled) {
				this.gShowPopup( evt.target )
				return;						// Return nothing
		}
		evt.preventDefault();
		switch(evt.button) {					// Switch to identify the mouse button clicked
		case 0:							// Left Click
			if (cButton.cleftclick && evt.ctrlKey) {	// Test for function presence And Ctrl Key
				cButton.cleftclick(evt)			// Test passed call the function
			}
			else if (cButton.aleftclick && evt.altKey){	// Test for function presence and Alt Key
				cButton.aleftclick(evt)			// Test passed call the function
			}
			else if (cButton.sleftclick && evt.shiftKey){// Test for function presence And Shift Key
				cButton.sleftclick(evt)			// Test passed call the function
			}
			else if (cButton.leftclick && lNaked ){	// Test for function presence
				cButton.leftclick(evt)			// Test passed call the function
			}
			else {					// All tests failed
				this.gShowPopup( evt.target );			// Pop up the Menu
			} // End if(cButton.leftclick && lNaked )
			break;						// Break from the switch Exit
		case 1:	// Middle Click                                // Middle Click
			if (cButton.cmidclick && evt.ctrlKey) {        // Test for function presence And Ctrl Key
				cButton.cmidclick(evt)                 // Test passed call the function
			}
			else if (cButton.amidclick && evt.altKey){   // Test for function presence And Alt Key
				cButton.amidclick(evt)                 // Test passed call the function
			}
			else if (cButton.smidclick && evt.shiftKey){ // Test for function presence And Shift Key
				cButton.smidclick(evt)                 // Test passed call the function
			}
			else if (cButton.midclick && lNaked ) {	// Test for function presence
				cButton.midclick(evt)                  // Test passed call the function
			}
			else {                                       // All tests failed
				this.gShowPopup(cButton);                   // Pop up the Menu
			} // End if(cButton.midclick && lNaked )
			break;                                         // Break from the switch Exit
		case 2:	// Right Click                                 // Right Click
			if (cButton.crightclick && evt.ctrlKey) {      // Test for function presence And Ctrl Key
				cButton.crightclick(evt)               // Test passed call the function
			}
			else if (cButton.arightclick && evt.altKey){ // Test for function presence And Alt Key
				cButton.arightclick(evt)               // Test passed call the function
			}
			else if (cButton.rightclick && lNaked ) {	// Test for function presence
				cButton.rightclick(evt)                // Test passed call the function
				break;
			}
			else {                                       // All tests failed
				this.gShowPopup(cButton);              // Pop up the Menu
			} // End if(cButton.rightclick && lNaked )
			break;
		default:
			this.gShowPopup(cButton);              // Pop up the Menu
		} // End switch(evt.button)
	}, //}}} End Method mHandler( evt, cButton )
	/**  gShowPopup( node )

	 Scope:		public
	 Args:		node - Button in focus
	 Returns:	Nothing
	 Called by:	1. this.mHandler
			2. Any process which passes node as an object
				 and will handle the Custom Buttons² context
				 menu.
	 Purpose: 	1. Display the Custom Buttons² context menu.
			2. No button author intervention expected.
	 UPDATED:		*  8/25/2007 - Added as an object in custombuttons
	**/
	gShowPopup:function ( node, menuId ) //{{{
	{
		if ( typeof menuId != 'string') menuId = 'custombuttons-contextpopup';
		var popup = document.getElementById( menuId );	// Get the menu
		var x = node.boxObject.x;						// Get xCoord.
		var y = node.boxObject.y + node.boxObject.height;			// Get yCoord.
		document.popupNode = node;						// Post node to document.
		popup.showPopup(node, x, y, "popup", null, null);			// Pop up the menu

	}  //}}} End Method gShowPopup( node )
}; //}}} End Object gQuot


/**  saveButtonsToProfile(  )
	Author Yan, George Dunham

	Args:
	Returns: Nothing
	Scope:	 public
	Called by:
		 1. Any process that wants to commit the buttons in gToolbox
				 to disk.
	Purpose:
		 1. Commit the custombuttons in the gToolbox to disk.
		 TODO:
**/
custombuttons.saveButtonsToProfile = function (  ) //{{{
{
	// alert('Save Buttons to Profile')
	var doc = document.implementation.createDocument("", "", null);
	var overlay = doc.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul","overlay");
	overlay.setAttribute('id','custombuttons-profile-overlay');
	doc.appendChild(overlay);
	// var scriptEl=doc.createElement('script');
	// scriptEl.setAttribute('type','application/x-javascript');
	// scriptEl.setAttribute('src','chrome://custombuttons/content/buttonsoverlay.js');
	// overlay.appendChild(scriptEl);
	var palette=doc.createElement('toolbarpalette');
	palette.setAttribute('id','BrowserToolbarPalette');
	overlay.appendChild(palette);
	var copiedAttributes={
		'class':true,
		'id':true,
		'label':true,
		'image':true,
//			'oncommand':true,
		'cb-oncommand':true,
		'cb-init':true,
		'context':true,
		'tooltiptext':true
	};

	//adding buttons from palette to new doc
	var aSortArr = new Array([],[],[]);
	for (var j=0;j<this.gToolbox.palette.childNodes.length;j++){
		var but=this.gToolbox.palette.childNodes[j];
		if (but.getAttribute('id').indexOf('custombuttons-button')!=-1){ 		// Our Kind of button
			var newButton=doc.createElement(but.nodeName);
			for (var a in copiedAttributes){
				if (but.getAttribute(a)) newButton.setAttribute(a,but.getAttribute(a));
			}
			// Build buttonsoverlay.xul sort array
			aSortArr[0].push(this.getNumber(newButton.getAttribute('id')));
			aSortArr[1].push(this.getNumber(newButton.getAttribute('id')));
			aSortArr[2].push(newButton);
		}
	}

	// function to sort numeric array
	function numsort(a,b){
		return a-b;
	}
	aSortArr[0].sort(numsort);
	var nIndex = -1;
	var tmp = '';
	for (var i in aSortArr[0]) {	// This arranges the palette in ID order
		nIndex = aSortArr[1].indexOf(aSortArr[0][i]);
		newButton = aSortArr[2][nIndex];
		palette.appendChild(newButton);
	} // End for

	// End Manage the New Button Buffer

	var serializer = new XMLSerializer();
	var data = serializer.serializeToString(doc);

	//beautifull output
	XML.prettyPrinting=true;
	data=(new XML(data)).toXMLString ();


	var uniConv = Components.classes['@mozilla.org/intl/scriptableunicodeconverter']
		.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	uniConv.charset = 'utf-8';
	data = uniConv.ConvertFromUnicode(data);

	var dir = Components.classes["@mozilla.org/file/directory_service;1"]
			 .getService(Components.interfaces.nsIProperties)
			 .get("ProfD", Components.interfaces.nsIFile); // get profile folder
	dir.append("custombuttons");
	if (!dir.exists()) {
		try{
			dir.create(0x01, 0755);
		} catch(e){
			var msg='[ '+cb2String.sOvrlyCB2Error+' ]\n'
				+'[ '+cb2String.sOvrlyCB2ErrorCreateDir+' ]\n'
				+'[ '+e+' ]';
			Components.utils.reportError(msg);
		}
	}

	//creating backup
	var backupfile=dir.clone();
	backupfile.append("buttonsoverlay.xul.bak");

	var file=dir.clone();
	file.append("buttonsoverlay.xul");
	if (file.exists()){
		if (backupfile.exists()) {
			backupfile.remove(false);
		}
		file.copyTo(dir,"buttonsoverlay.xul.bak");
	}

	var foStream = Components.classes['@mozilla.org/network/file-output-stream;1']
		.createInstance(Components.interfaces.nsIFileOutputStream);
		var flags = 0x02 | 0x08 | 0x20; // wronly | create | truncate
		foStream.init(file, flags, 0755, 0);
		foStream.write(data, data.length);
		foStream.flush();
		foStream.close();
}; //}}} End Method saveButtonsToProfile(  )


/**  isPref( sPrefId, aDefault )
	Author	 George Dunham

	Args:	 aprefId - Preference ID string
		 aDefault - Default Preference Value
	Returns: lRet - Boolean, true if the preference exists.
	Scope:	 public
	Called:	 By:
		 1. Any process which passes aprefId and will accept
				a boolean return.
		 2. Passing the optional [Default] will cause the pref
				to be created if not defined.
	Purpose: To:
		 1. Test for the presence of a specified pref.
		 NOTE: Inserted with ver. 2.0.02a
**/
custombuttons.isPref = function ( sPrefId, aDefault ) //{{{
{
	var lRet = this.ps.prefHasUserValue( sPrefId );
	if ( typeof aDefault != CB2const.VOID && !lRet ) {
		this.setPrefs( sPrefId, aDefault )
		lRet = true;
	} // End if ( typeof aDefault != CB2const.VOID && !rRet )
	return lRet;
}; //}}} End Method isPref( sPrefId, aDefault )
/**  getPrefs( sPrefId )
	Author	 George Dunham

	Args:	 sPrefId - Preference ID string
	Returns: rRet - Preference value in the correct type.
		 1. null if Preference ID not in about:config list.
	Scope:	 public
	Called:	 By:
		 1. Any process passing a prefid string and accepting
				its value.
	Purpose: To:
		 1. Return the pref specified in sPrefId
		 NOTE: Inserted with ver. 2.0.02a
**/
custombuttons.getPrefs = function ( sPrefId ) //{{{
{
	var rRet = null;
	var nsIPrefBranchObj = this.ps.getBranch( null );
	switch ( nsIPrefBranchObj.getPrefType( sPrefId ) ){
	case 32:						// string
		rRet = nsIPrefBranchObj.getCharPref( sPrefId );
		break;
	case 64:						// number
		rRet = nsIPrefBranchObj.getIntPref( sPrefId );
		break;
	case 128:						//  boolean
		rRet = nsIPrefBranchObj.getBoolPref( sPrefId );
		break;
	default:
		rRet = null;
	}
	return rRet;
}; //}}} End Method getPrefs( sPrefId )
/**  setPrefs( sPrefId, prefValue )
	Author	 George Dunham

	Args:	 sPrefId - Preference ID string
		 prefValue - Value to set into the Preference ID.
	Returns: Nothing
	Scope:	 public
	Called by:
		 1. Any process which passes a pref id and it's new value.
	Purpose: To:
		 1. Modify the specified pref to the passed value.
		 NOTE: Inserted with ver. 2.0.02a
**/
custombuttons.setPrefs = function ( sPrefId, prefValue ) //{{{
{
	var nsIPrefBranchObj = this.ps.getBranch(null);
	switch (typeof prefValue){
	case CB2const.VOID:
		break;
	case CB2const.STRING:
		nsIPrefBranchObj.setCharPref( sPrefId, prefValue );
		this.ps.savePrefFile( null );
		break;
	case CB2const.NUMBER:
		nsIPrefBranchObj.setIntPref( sPrefId, prefValue );
		this.ps.savePrefFile( null );
		break;
	case CB2const.BOOLEAN:
		nsIPrefBranchObj.setBoolPref( sPrefId, prefValue );
		this.ps.savePrefFile( null );
		break;
	default:
	}
}; //}}} End Method setPrefs( sPrefId, prefValue )


/**  confirmBox( sTitle, xstr, butTitle1, butTitle2 )
	Author	George Dunham

	Args:	 sTitle
		 xstr
		 butTitle1
		 butTitle2
	Returns: button
	Scope:	 private
	Called:	 By:
		 1.
	Purpose: To:
		 1. Provide a means for the operator to confirm an action.
		 TODO:
**/
custombuttons.confirmBox = function ( sTitle, xstr, butTitle1, butTitle2 ) //{{{
{
	let button = null;
	let prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		.getService(Components.interfaces.nsIPromptService);
	let flags = prompts.BUTTON_POS_0 * prompts.BUTTON_TITLE_IS_STRING;
	if (butTitle2) {
		flags += prompts.BUTTON_POS_1 * prompts.BUTTON_TITLE_IS_STRING;
		// UPDATED: 10/10/2007 to enable modification of the second button
		//butTitle2 = '';
	}
	button = prompts.confirmEx(null, sTitle, xstr, flags, butTitle1, butTitle2,'','',{});
	return ( button === 0 );
}; //}}} End Method confirmBox( sTitle, xstr, butTitle1, butTitle2 )
/**  alertBox( sTitle, xstr )
	Author George Dunham

	Args:	 sTitle
		 xstr
	Returns: Nothing
	Scope:	 private
	Called:	 By:
		 1.
	Purpose: To:
		 1. Provide a means for the operator to receive a message
		 TODO:
**/
custombuttons.alertBox = function ( sTitle, xstr ) //{{{
{
	let prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
		.getService(Components.interfaces.nsIPromptService);
	prompts.alert(null, sTitle, xstr );
}; //}}} End Method alertBox( sTitle, xstr )



